// Cpp_controller_solution.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "VISA_GPIB_Manager.h"
#include "VISA_RS232_Manager.h"
#include "MS_VS_2005_RS232_manager.h"
#include "LAN_Sockets_Ethernet_class.h"
#include "Engineering_File_Writer_IO_class.h"
#include "IEEE_488_GPIB_manager.h"
#include  "ANSI_C_EULA.h"


VISA_GPIB_Manager                Generic_VISA_GPIB_class;
MS_VS_2005_RS232_manager         Generic_Microsoft_RS232_class;
LAN_Socket_Ethernet_class        Generic_Microsoft_Ethernet_class;
Engineering_File_Writer_IO_class Generic_file_writer_class;
IEEE_488_GPIB_manager            Generic_NI488_GPIB_class;
VISA_RS232_Manager               Generic_RS232_class;


int main( )
{

	system("color 0C");

EULA_notice( );// do not sue me or screw me notice


	Generic_Microsoft_RS232_class.Report_availible_COM_ports();
	Generic_VISA_GPIB_class.Detect_Avalible_VISA_Interfaces();
	Generic_NI488_GPIB_class.Report_avalible_GPIB_interfaces();
	Generic_RS232_class.Detect_Avalible_VISA_Interfaces();
	fprintf(stderr,"Tap any key to exit.......");

	getchar();


	return 0;
}

