












/* EXAMPLE USAGE EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE 



   VISA_GPIB_Manager Agilent_MUX_board_34970A_GPIB_VISA;





  Agilent_MUX_board_34970A_GPIB_VISA.Detect_Avalible_VISA_Interfaces();
  Agilent_MUX_board_34970A_GPIB_VISA.Designate_GPIB_Address("GPIB0::10::INSTR"); 


  Use the "Detect_Avalible_VISA_Interfaces()" to find your GPIB address.


  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE  EXAMPLE USAGE */






#include <windows.h>
#include <stdio.h>


#include "visa.h"                   //Find this in National Instruments Library
#include "visatype.h"               //Find this in National Instruments Library
#pragma comment( lib, "visa32.lib" )//Only works for Microsoft Development Studio/


#ifndef _VISA_GPIB_Manager_dot_h_
#define _VISA_GPIB_Manager_dot_h_

#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **            _VISA_GPIB_Manager_dot_h_                       *  \n")
#pragma message("\n **                January 22, 2014                            *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")




/***************  COMPILER strcpy_s appeasement ********
  Need to use a # define to appease  strcpy_s
******************  ___________________ ***************/
#ifndef   define_250_chars  
#define   define_250_chars  250
#endif


class VISA_GPIB_Manager
{
   private:

	   //************************* Varible Declaration zone ************************
	  
	
	   
	   // unsigned long varibles
       unsigned long pvt_Actual_Bytes_Transmitted;   // The actual number of bytes transmitted to GPIB
	   unsigned long pvt_Actual_Bytes_Received;      // The actual number of bytes transmitted to GPIB
	   unsigned char pvt_GPIB_INT_flag;              // = 0XFF when GPIB is initilised OK 


	  //Magical VISA entities	   
	   ViSession     pvt_VISA_Resorce_ID;               // This must be set prior to summons to any of the                               
	   ViSession     pvt_Default_Resource_Manager;      // Default Resource manager;

	   //char array
	   char          pvt_GPIB_address[define_250_chars];//
	   char          pvt_BELL_array[define_250_chars];  // an array of three char(7);
   
	   // single chars
	   char          pvt_char_YN;

	   //* FILE PNTR
   
      FILE          *pvt_Report_VISA_INTRFACE_FILE_pntr;// Writes the engineering file

      errno_t       pvt_File_Open_Error;                // Magical varible: Abra Cadabra


	  
	   void VISA_GPIB_Manager::pvt_Acknolege_Message()
	   {
		   
        pvt_char_YN='n';
		while ('y'!=pvt_char_YN)
		{
	      printf("Tap a 'y' key to acknowlege this message......");
		  pvt_char_YN =getchar();
		}
		   
		   return;//Nothing
	   };//END VISA_RS232_Manager::pvt_Acknolege_Message()

        
     void  VISA_GPIB_Manager::Designate_GPIB_Address_Error_Message()
	{// Generic error message for SetAttribute_Error_Check
	
		pvt_char_YN ='n';
		while ('y'!=pvt_char_YN)
		{
			 system("cls");
	         printf("******************** ERROR ALERT!  ***********************\n");
	         printf("*                                                        *\n");
	         printf("*       Non valid result from  ''viOpenDefaultRM''       *\n");
	         printf("*                                                        *\n");
	         printf("*         VISA_GPIB_Manager will now puke on you.        *\n");
			 printf("*                                                        *\n");
			 printf("*                                                        *\n");
	         printf("******************** ERROR ALERT!  ***********************\n");
			
	         printf("%s",pvt_BELL_array);
	
	         printf("\n\n\n");
	         printf("Tap ''y'' key to acknowlege this message.\n");
             pvt_char_YN = getchar();
		}
	         //cin.get();
	}








         
	   int  VISA_GPIB_Manager::VISA_Resorce_ID_Error_Message( )//ERROR TESTING
	   {
		//********************************************************************
	     //  This function is summoned when some attempts to use any of these *
	     // classes without initiliseing "pvt_VISA_Resorce_ID"                    *
	     //********************************************************************

		   if (0X00==pvt_GPIB_INT_flag)//Original value is bogus
		   {
			system("cls");

	     
	     

             pvt_char_YN ='n';
		while ('y'!=pvt_char_YN)
		{
			 system("cls");
	         printf("******************** ERROR ALERT!  ***********************\n");
	         printf("*                                                        *\n");
	         printf("*            pvt_VISA_Resorce_ID is not intialised!      *\n");
	         printf("*                                                        *\n");
			 printf("*   The GPIB addres that you furnished:                 *\n");
			 printf("*       %s*\n",pvt_GPIB_address );
			 printf("*                                                        *\n");
			 printf("*  might not be the correct format!                      *\n");
			 printf("*                                                        *\n");
			 printf("*                                                        *\n");
			 printf("* An example of a corrrect GPIB address is :             *\n");
			 printf("*                                                        *\n");
			 printf("*              ''GPIB0::22::INSTR''                      *\n");
		     printf("*                                                        *\n");
			 printf("*                                                        *\n");
			 printf("*  USE    ''Detect_Avalible_VISA_Interfaces()''          *\n");
			 printf("*                                                        *\n");
	         printf("*           VISA_GPIB_Manager will now puke on you.      *\n");
	         printf("*                                                        *\n");
	         printf("******************** ERROR ALERT!  ***********************\n");
			
	         printf("%s",pvt_BELL_array);
	
	         printf("\n\n\n");
	         printf("Tap ''y'' key to acknowlege this message.\n");
             pvt_char_YN = getchar();
		}

               

			  //Detect_Avalible_VISA_Interfaces()
			return -1;//ERROR code

		   }
	   
        return +1;// OK test code

	   } //END   VISA_Resorce_ID_Error_Message *********************************


     unsigned char pvt_unsigned_char_array_to_char_array(unsigned char  Source_unsigned_char_array[], char Destination_char_array[], unsigned int Array_Length)
	 {
        unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_char_array[byte_index] = (char) Source_unsigned_char_array[byte_index];
		 }

        return reply_message;
	 }


	  unsigned char pvt_char_array_to_unsigned_char_array(char Source_char_array[], unsigned char Destination_unsigned_char_array[], unsigned int Array_Length)
	{

		unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_unsigned_char_array[byte_index] = (unsigned char) Source_char_array[byte_index];
		 }

        return reply_message;
	}




























   public:

        // Class constructor
        VISA_GPIB_Manager::VISA_GPIB_Manager()//Initilise internal varibles
	   {
	    
		pvt_GPIB_INT_flag =0X00;// Device has not been intialised
		strcpy_s(pvt_GPIB_address,250,"NOT_INITIALISED_YET");

		pvt_BELL_array[0]=(char) 7;
		pvt_BELL_array[1]=(char) 7;
		pvt_BELL_array[2]=(char) 7;
		pvt_BELL_array[3]='\0';

		
	   
	   };//END VISA_GPIB_Manager::VISA_GPIB_Manager



		// Class destructor
        VISA_GPIB_Manager::~VISA_GPIB_Manager()//Initilise internal varibles
	   {
		  viClose (pvt_VISA_Resorce_ID);             //Close VISA session.
		  viClose (pvt_Default_Resource_Manager);    //Close VISA session.
		};//END  VISA_GPIB_Manager::~VISA_GPIB_Manager
                
       
      ViStatus  VISA_GPIB_Manager::Designate_GPIB_Address(char Requested_GPIB_Address[])
	 {
           static ViStatus VISA_status;


          pvt_GPIB_INT_flag =0X00;
      
          VISA_status = viOpenDefaultRM (&pvt_Default_Resource_Manager);  

		  if (0!=VISA_status)
		  {
			  Designate_GPIB_Address_Error_Message();
			  return VISA_status;
		  }
		 
		  strcpy_s(pvt_GPIB_address,100,Requested_GPIB_Address);

          VISA_status = viOpen (pvt_Default_Resource_Manager, pvt_GPIB_address, VI_NULL,VI_NULL, &pvt_VISA_Resorce_ID); // 

		  if (0!=VISA_status)
		  {
		    VISA_Resorce_ID_Error_Message( );
			return VISA_status;
			 
		  }

           pvt_GPIB_INT_flag =0XFF;

		   return VISA_status;
	 }


      void  VISA_GPIB_Manager::Display_Typical_Device_ID()
	  {
         
        printf(" \n");
		printf("/*                                                                             */ \n");
		printf("/*                                                                             */ \n");
		printf("// * Find all the VISA resources in our system and store the number of resources \n");
		printf("// * in the system in numInstrs.  Notice the different query descriptions a \n");
	    printf("// * that are available. \n");
		printf("// \n");
	    printf("//     Interface         Expression \n");
	    printf("// ------------------------------------------------- \n");
		printf("//    GPIB             ''GPIB[0-9]*::?*INSTR''                                  * \n");
	    printf("//    VXI              ''VXI?*INSTR''                                           * \n");
		printf("//    GPIB-VXI         ''GPIB-VXI?*INSTR''                                      * \n");
		printf("//    Any VXI          ''?*VXI[0-9]*::?*INSTR''                                 * \n");
		printf("//    Serial           ''ASRL[0-9]*::?*INSTR''                                  * \n");
		printf("//    PXI              ''PXI?*INSTR''                                           * \n");
	    printf("//    All instruments  ''?*INSTR''                                              * \n");
		printf("//    All resources    ''?*'                                                    *\n");
	    printf(" //                                                                             */ \n");
	    printf(" //                                                                             */ \n");
		printf(" //                                                                             */ \n");
	    printf(" \n");

	     printf("\n\n\n");
	     printf("Tap ''y'' key to acknowlege this message.\n");
         pvt_char_YN = getchar();

	  }
    
    
    
    
    
   
    
              
   


	   int VISA_GPIB_Manager::Detect_Avalible_VISA_Interfaces()
	   {//****************** Varible Declaration Zone *************************
         // char Arrays
      
		 // VISA Varibles 
         static char instrDescriptor[VI_FIND_BUFLEN];
         static ViUInt32 Num_VISA_Resources;
         static ViFindList findList;
         static ViSession defaultRM, instr;
         static ViSession MY_Instument;
         static ViStatus pvt_status;

		  FILE *VISA_interfaces_report_FILE_pntr;



		
	     printf("\n\n\n''Detect_Avalible_VISA_Interfaces'' summoned. \n\n Need to wait for up to 60seconds.\n\n\n\n");
	     Sleep(500);
   
		 /* First we will need to open the default resource manager. */
         pvt_status = viOpenDefaultRM (&defaultRM);
         if (pvt_status < VI_SUCCESS)
        {
          printf("******************** ERROR ALERT!  ***********************\n");
	      printf("*                                                        *\n");
	      printf("* Could not open a session to the VISA Resource Manager! *\n");
	      printf("*                                                        *\n");
	      printf("******************** ERROR ALERT!  ***********************\n");
	      printf("%s\n",pvt_BELL_array);
	      printf("\n\n\n");
	      pvt_Acknolege_Message();
          exit (EXIT_FAILURE);
         }  

         /*
         * Find all the VISA resources in our system and store the number of resources
         * in the system in numInstrs.  Notice the different query descriptions a
         * that are available.

           Interface         Expression
           --------------------------------------
           GPIB              "GPIB[0-9]*::?*INSTR"
           VXI               "VXI?*INSTR"
           GPIB-VXI          "GPIB-VXI?*INSTR"
           Any VXI           "?*VXI[0-9]*::?*INSTR"
           Serial            "ASRL[0-9]*::?*INSTR"
           PXI               "PXI?*INSTR"
           All instruments   "?*INSTR"
           All resources     "?*"  
           a*/


		 
     

    //***************************** OPEN DEFAULT VISA OBJECT **********************************

    pvt_status = viFindRsrc (defaultRM, "?*", &findList, &Num_VISA_Resources, instrDescriptor);
    if (pvt_status < VI_SUCCESS)
    {

	   printf("******************** ERROR ALERT!  ***********************\n");
	   printf("*                                                        *\n");
	   printf("*  A default VISA Resource Manager can not be opened     *\n");
	   printf("*                                                        *\n");
	   printf("*            VISA Resource Manager puked!                *\n");
	   printf("*                                                        *\n");
	   printf("******************** ERROR ALERT!  ***********************\n");
	   printf("%s\n",pvt_BELL_array);
	   printf("\n\n\n");
	 pvt_Acknolege_Message();
	 
      viClose (defaultRM);
	  return 0;

   }
   //***************************** OPEN DEFAULT VISA OBJECT **********************************
   
	// File_Open_Error = fopen_s(&pvt_Engineering_file_writer,Reserved_File_Name_Array, "w");

	 pvt_File_Open_Error = fopen_s(&VISA_interfaces_report_FILE_pntr,"Avalible_VISA_Interfaces_Report.txt", "w+"); 


	 if ((0!=pvt_File_Open_Error)||(NULL==VISA_interfaces_report_FILE_pntr))
	 {
		  pvt_char_YN='n';
		  while ('y'!=pvt_char_YN)
		  {
		   printf("\n\n\n");
           printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*  ''Detect_Avalible_VISA_Interfaces'' puked on you.     *\n");
	       printf("*                                                        *\n");
		   printf("* Can not open ''Avalible_VISA_Interfaces_Report.txt''   *\n");
		   printf("*                                                        *\n");
		   printf("*                                                        *\n");
		   printf("*   You might need to restart your machine to purge the  *\n");
		   printf("* abandoned file pointers.                               *\n");
		   printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n", pvt_BELL_array);
	       printf("\n\n\n");
	       printf("Tap 'y' to acknowlege this message.");
		   pvt_char_YN = getchar();
		  }
		  return -1;//Error

	 };//END if ((0!=pvt_File_Open_Error)||(NULL==VISA_interfaces_report_FILE_pntr))

	 fclose(VISA_interfaces_report_FILE_pntr);


	 //********************************** FIND ANY INTERFACE  **********************************
	 //
     //  This section finds all of the VISA resources.  This is important since some ports do not
     // have a predefined protocol. An example of this is the RS 232 serial port. These ports do
     // not respond to an "*IDN?\n" request if the protocol if the protocol adjustments are not
     // set proporly. 
 
 
     Num_VISA_Resources++;//Accomadates the next while statement
  
     while (--Num_VISA_Resources) /* stay in this loop until we find all instruments */
    {
	
      if (pvt_status < VI_SUCCESS) 
      {   /* did we find the next resource? */
		 
		  
           printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*            VISA Resource Manager puked!                *\n");
	       printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n", pvt_BELL_array);
	        pvt_Acknolege_Message();
         
       viClose (defaultRM);
	  

         
      } 

	  fopen_s(&VISA_interfaces_report_FILE_pntr,"Avalible_VISA_Interfaces_Report.txt", "a");

      fprintf(VISA_interfaces_report_FILE_pntr,"VISA Interface(%i)=%s\n",Num_VISA_Resources,instrDescriptor);
	  printf("VISA Interface(%i)=%s\n",Num_VISA_Resources,instrDescriptor);
	  fclose(VISA_interfaces_report_FILE_pntr);


	 
	 //Resource_ID_Num++;
    
      pvt_status = viFindNext (findList, instrDescriptor);  /* find next desriptor */ 
   }    /* end while */
   //********************************END FIND ANY INTERFACE ******************************/

	 system("Avalible_VISA_Interfaces_Report.txt");

       
 
         return 0;
	   }//int VISA_GPIB_Manager::Detect_Avalible_VISA_Interfaces()


;


         ViStatus VISA_GPIB_Manager::Transmitt_a_BYTE_array_to_GPIB(unsigned char GPIB_BYTE_Array[], unsigned long Desired_Number_of_Bytes, unsigned long &Actual_Write_Count )
	     {
			

            static ViStatus GPIB_status;       //Returns status from VISA functions 0 if OK
	  
		    // Check for intilisation
			if (0XFF!=pvt_GPIB_INT_flag)
			{
             VISA_Resorce_ID_Error_Message();
			 return -1;

			}
			
            GPIB_status   = viWrite (pvt_VISA_Resorce_ID, (ViBuf)GPIB_BYTE_Array, Desired_Number_of_Bytes, &Actual_Write_Count);//VI_Status

			
			if (0!=GPIB_status)
			{
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*            ''Transmitt_a_BYTE_array_to_GPIB'' puked!   *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            pvt_char_YN = getchar();
			 return -1;
			}

        

			return GPIB_status;
	           	
		 };//END    ViStatus VISA_GPIB_Manager::Transmitt_a_BYTE_array_to_GPIB





		 ViStatus VISA_GPIB_Manager::Transmitt_a_char_array_to_GPIB( char GPIB_char_array[], unsigned long Desired_Number_of_chars, unsigned long &Actual_Write_Count )
	     {
			

            static ViStatus GPIB_status;       //Returns status from VISA functions 0 if OK

			unsigned char Ausgang_BYTE_array[500];
	  
		    // Check for intilisation
			if (0XFF!=pvt_GPIB_INT_flag)
			{
             VISA_Resorce_ID_Error_Message();
			 return -1;

			}


            pvt_char_array_to_unsigned_char_array(GPIB_char_array, Ausgang_BYTE_array, ((unsigned int )Desired_Number_of_chars));
			
            GPIB_status   = viWrite (pvt_VISA_Resorce_ID, (ViBuf)Ausgang_BYTE_array, Desired_Number_of_chars, &Actual_Write_Count);//VI_Status

			
			
			if (0!=GPIB_status)
			{
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*            ''Transmitt_a_char_array_to_GPIB'' puked!   *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            pvt_char_YN = getchar();
			 return -1;
			}


        

			return GPIB_status;
	           	
		 };//END    ViStatus VISA_GPIB_Manager::Transmitt_a_BYTE_array_to_GPIB






         ViStatus VISA_GPIB_Manager::Receive_a_BYTE_array_from_GPIB(unsigned char GPIB_BYTE_Array[], unsigned long &Number_of_BYTEs_received )
		 {
          	
            unsigned long      MAX_read_count;    // This is the number of bytes written to RS232
            static   ViStatus  GPIB_status;       //Returns status from VISA functions 0 if OK

			// Check for intilisation
			if (0XFF!=pvt_GPIB_INT_flag)
			{
             VISA_Resorce_ID_Error_Message();
			 return -1;
			}
			


			MAX_read_count = Number_of_BYTEs_received;
			if (500>MAX_read_count)
			{

			  MAX_read_count = 500;
			                       //   There is a trap here.  If you assign an unsufficiently large number for
			                       // the maximum expected bytes, then you might lose some data!
			}


            GPIB_status = viRead (pvt_VISA_Resorce_ID, (ViBuf)GPIB_BYTE_Array, MAX_read_count, &Number_of_BYTEs_received);


			if (0!=GPIB_status)
			{
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*            ''Receive_a_BYTE_array_from_GPIB'' puked!          *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            pvt_char_YN = getchar();
			 return -1;
			}

		
           return GPIB_status;
		 };//END ViStatus VISA_GPIB_Manager::Receive_a_BYTE_array_from_GPIB





	  


             ViStatus VISA_GPIB_Manager::Receive_a_char_array_from_GPIB( char GPIB_char_array[], unsigned long &Number_of_BYTEs_received )
		 {
          	
            unsigned long      MAX_read_count;    // This is the number of bytes written to RS232
            static   ViStatus  GPIB_status;       //Returns status from VISA functions 0 if OK

			unsigned char GPIB_BYTE_array[500];

			// Check for intilisation
			if (0XFF!=pvt_GPIB_INT_flag)
			{
             VISA_Resorce_ID_Error_Message();
			 return -1;
			}
			
          

			Number_of_BYTEs_received =500;
		    MAX_read_count = Number_of_BYTEs_received;
			if (500>MAX_read_count)
			{

			  Number_of_BYTEs_received = 500;
			                       //   There is a trap here.  If you assign an unsufficiently large number for
			                       // the maximum expected bytes, then you might lose some data!
			}


            GPIB_status = viRead (pvt_VISA_Resorce_ID, (ViBuf)GPIB_BYTE_array, MAX_read_count, &Number_of_BYTEs_received);


			if (0!=GPIB_status)
			{
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*            ''Receive_a_BYTE_array_from_GPIB'' puked!          *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            pvt_char_YN = getchar();
			 return -1;
			}

			pvt_unsigned_char_array_to_char_array(GPIB_BYTE_array, GPIB_char_array, ((unsigned int)Number_of_BYTEs_received));
		
           return GPIB_status;
		 };//END ViStatus VISA_GPIB_Manager::Receive_a_BYTE_array_from_GPIB






	
	  



};//END class VISA_GPIB_Manager




/************************* MR. Murphy ALERT ***************************************** 
 
  MR. Murphy's C++ compiler poetry:

  Stinker linker if you blink
  your life will stink
  your spirit will sink
  your account has red ink
  Linker stinker blink

************************* ____________________ *************************************/




#endif 