

/* WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 
  You MUST down load the NI-VISA from National Instruments.  You must have 
  permission from National Instuments to own and use NI-VISA software.
 WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING */
/*

There are three files that must reside in the same directory as this  *.h file:


1) "visa32.lib" -or- "visa64.lib"
2) visa.h
3) visatype.h


Instuctions for "visa32.lib" -or- "visa64.lib"

 A1)Use your computer's search function to find  where the following files are
    hidden: "oleaut32.lib uuid.lib odbc32.lib odbccp32.lib"


     On my machine this is located in

     "C:\Program Files\Microsoft Visual Studio\VC98\Lib

 A2) Place a copy of "visa32.lib"  or  "visa64.lib" in this directory.



  B) Alternatively, try adding the following lines in the header file.
    
	#pragma comment( lib, "visa32.lib" ) (Windows ONLY)
	-OR-
	#pragma comment( lib, "visa64.lib" ) (Windows ONLY)
 




  Instuctions on "visa.h" and "visatype.h" 

     A) This is a standard "#include" file. you MUST place "visa.h" above the "visatype.h"
   file.

 


/*************** READ ME READ ME READ ME READ ME  READ ME *************************

	This class allows you to modify the RS232 parameters on the SOFTWARE end. YOU
are responsible for discovering what are the hardware settings. Also RS232 does not 
have a predefined protocol(BAUD rate, parity, bits, ect). You must adjust the low 
level communicaions protocols yourself. 

  Again, these functions only adjust SOFTWARE parameters!
    
  Find your equipment manual and query what are the stored parameters. You typically
do this by jabbing buttons on the equipment interface.


*************** READ ME READ ME READ ME READ ME  READ ME *************************/








/****** EXAMPLE USAGE EXAMPLE USAGE EXAMPLE USAGE EXAMPLE USAGE EXAMPLE USAGE  *****
   


VISA_RS232_Manager Fluke_Hart_RS232_class;// Defined in VISA_RS232_Manager.h


    Fluke_Hart_RS232_class.ADJ_COM_ID_number(15);
	Fluke_Hart_RS232_class.ADJ_BAUD_to_9600();
	Fluke_Hart_RS232_class.ADJ_TIME_OUT_milliseconds(500);
	Fluke_Hart_RS232_class.ADJ_FLOW_CNTRL_NONE();
	Fluke_Hart_RS232_class.ADJ_PARITY_NONE();
	//Fluke_Hart_RS232_class.DISPLAY_RS232_SETTINGS();
 


  ****** EXAMPLE USAGE EXAMPLE USAGE EXAMPLE USAGE EXAMPLE USAGE EXAMPLE USAGE  ******/








#include <windows.h>
#include <stdio.h>

#include "visa.h"               //Find this in National Instruments Library
#include "visatype.h"           //Find this in National Instruments Library



#ifndef _VISA_RS232_Manager_dot_h_
#define _VISA_RS232_Manager_dot_h_

#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **           _VISA_RS232_Manager_dot_h_                       *  \n")
#pragma message("\n **                January 27, 2014                            *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")

/***************  COMPILER strcpy_s appeasement ********
  Need to use a # define to appease  strcpy_s
******************  ___________________ ***************/
#ifndef   define_256_chars  
#define   define_256_chars  (256)
#endif

  #pragma comment( lib, "visa32.lib" )


class VISA_RS232_Manager
{
   private:

	   //************************* Varible Declaration zone ************************
       
	   
	   
	   // MAGICAL VISA VARIBLES
	   ViStatus      pvt_status;                 // this is a generic return value of a VISA summons 
	   ViAttrState   pvt_VISA_Reply_Attribute;   //This is the reply form VISA command
	   ViAttrState   pvt_VISA_Request_Attribute;  //This the primary attribute request


	  


	   //boolean varibles 
	   // bool pvt_Valid_Data_Detected;              // User error checking

	   // Magical VISA varibles	   
	   ViSession  pvt_VISA_Resorce_ID;             // This must be set prior to summons to any of the                                
	   ViSession  pvt_Default_Resource_Manager;    // Default Resource manager;

	   // char arrays 
	   char pvt_Bell_Array[define_256_chars];       // Used in generating beeps

	   // Magical variables 
	   errno_t       pvt_File_Open_Error;             // Magical varible: Abra Cadabra

	  
	  unsigned int  pvt_ASRL_Number;



	 


	   


	   void  VISA_RS232_Manager::pvt_Acknowlege_Message()
	   {
		   
        char pvt_YES_NO='n';
		while ('y'!=pvt_YES_NO)
		{
	      printf("Tap 'y' key to acknowlege this message......");
		  pvt_YES_NO = getchar();
		}
		   
		   return;//Nothing
	   };//END VISA_RS232_Manager::pvt_Acknowlege_Message()


unsigned char VISA_RS232_Manager::pvt_adjust_PARITY(  ViAttrState   Requested_PARITY )
{

	       unsigned char Reply_Message;
	       ViAttrState Actual_Parity;

           char Actual_Parity_message[define_256_chars];
		   char Requested_Parity_message[define_256_chars];
   
		   char pvt_YES_NO;



		   Has_COM_PORT_Been_Selected_yet();

		   if (0>VISA_Resorce_ID_Examination())
		   {
			Reply_Message = 0X01;
			 return Reply_Message;//Error code
		   }


//             pvt_Valid_Data_Detected=false;//



		   
	        pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_PARITY, Requested_PARITY);
			 
		   if (0>pvt_status)
		   {
		      viSetAttribute_Error_Message();//Display generic error message

			  Reply_Message = 0X02;
			 return Reply_Message;//Error code
		   }

		  
           pvt_VISA_Reply_Attribute =0;// Known initilisation
	       pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_PARITY, &pvt_VISA_Reply_Attribute);

		   if (0>pvt_status)
		   {
		      viGetAttribute_Error_Message();//Display generic error message
		      Reply_Message = 0X04;
			 return Reply_Message;//Error code
		   }

		   Actual_Parity = pvt_VISA_Reply_Attribute;//WTF????

           
		  
           if (VI_ASRL_PAR_NONE==Requested_PARITY)
		   {
             strcpy_s(Requested_Parity_message,define_256_chars,"VI_ASRL_PAR_NONE");
		   }

		   
           if (VI_ASRL_PAR_ODD==Requested_PARITY)
		   {
             strcpy_s(Requested_Parity_message,define_256_chars,"VI_ASRL_PAR_ODD");
		   }

		   
           if (VI_ASRL_PAR_EVEN==Requested_PARITY)
		   {
             strcpy_s(Requested_Parity_message,define_256_chars,"VI_ASRL_PAR_EVEN");
		   }

		   
           if (VI_ASRL_PAR_MARK==Requested_PARITY)
		   {
             strcpy_s(Requested_Parity_message,define_256_chars,"VI_ASRL_PAR_MARK");
		   }


		    if (VI_ASRL_PAR_SPACE==Requested_PARITY)
		   {
             strcpy_s(Requested_Parity_message,define_256_chars,"VI_ASRL_PAR_SPACE");
		   }



           if (VI_ASRL_PAR_NONE==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(Actual_Parity_message,define_256_chars,"VI_ASRL_PAR_NONE");
		   }

		   
           if (VI_ASRL_PAR_ODD==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(Actual_Parity_message,define_256_chars,"VI_ASRL_PAR_ODD");
		   }

		   
           if (VI_ASRL_PAR_EVEN==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(Actual_Parity_message,define_256_chars,"VI_ASRL_PAR_EVEN");
		   }

		   
           if (VI_ASRL_PAR_MARK==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(Actual_Parity_message,define_256_chars,"VI_ASRL_PAR_MARK");
		   }


		    if (VI_ASRL_PAR_SPACE==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(Actual_Parity_message,define_256_chars,"VI_ASRL_PAR_SPACE");
		   }


            if (Actual_Parity!=pvt_VISA_Reply_Attribute)
			{


			  system("cls");
              printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*  The actual VISA value of ''PAIRTY'' does not agree    *\n");
			  printf("*   with the requested''PAIRTY''  value!!                *\n");
	          printf("*                                                        *\n");
			  printf("*    ACTUAL ''PARITY''VALUE =%s     *\n",Actual_Parity_message);
			  printf("*                                                        *\n");
			  printf("* REQUESTED ''PARITY''VALUE =%s     *\n",Requested_Parity_message);
			  printf("*                                                        *\n");
	          printf("*           VISA_RS232_Manager will now puke on you.     *\n");
	          printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("%s\n",pvt_Bell_Array);

		      printf("\n\n\n");
		     
			  pvt_YES_NO='n';
		      while ('y'!=pvt_YES_NO)
		      {
	           printf("Tap any key to acknowlege this message......");
			   getchar();
		      }

			   Reply_Message = 0X08;//Error code
			 return Reply_Message;

			} 

		 
          Reply_Message = 0X00;
        return Reply_Message;//Error code
}


   

 unsigned char VISA_RS232_Manager::pvt_adjust_FLOW_CONTROL(  ViAttrState   Requested_FLOW_CONTROL )
 {
   unsigned char Reply_Message =0X00;  


   char Actual_FLOW_CNTRL_message    [define_256_chars];
   char Requested_FLOW_CNTRL_message [define_256_chars];


    Has_COM_PORT_Been_Selected_yet();


     if (0>VISA_Resorce_ID_Examination())
	  {
	    Reply_Message = 0X01;
	    return Reply_Message;//Error code
	  }


	   pvt_VISA_Request_Attribute = Requested_FLOW_CONTROL;
		 
	   pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_FLOW_CNTRL, pvt_VISA_Request_Attribute);
	  
	   if (0>pvt_status)
	   {
		 viSetAttribute_Error_Message();//Display generic error message
	     Reply_Message = 0X02;
	     return Reply_Message;//Error code
	    }

	    pvt_VISA_Reply_Attribute = 0;
		pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_FLOW_CNTRL, &pvt_VISA_Reply_Attribute);
	
		if (0>pvt_status)
		 {
		  viGetAttribute_Error_Message();//Display generic error message
		  Reply_Message = 0X04;
		  return Reply_Message;//Error code
		 }


		
		



		if (VI_ASRL_FLOW_NONE==Requested_FLOW_CONTROL)
		{
            strcpy_s(Requested_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_NONE");
		}

		if (VI_ASRL_FLOW_XON_XOFF==Requested_FLOW_CONTROL)
		{
            strcpy_s(Requested_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_XON_XOFF");
		}

        if (VI_ASRL_FLOW_RTS_CTS==Requested_FLOW_CONTROL)
		{
            strcpy_s(Requested_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_RTS_CTS");
		}

		 if (VI_ASRL_FLOW_DTR_DSR==Requested_FLOW_CONTROL)
		{
            strcpy_s(Requested_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_DTR_DSR");
		}


         strcpy_s(Actual_FLOW_CNTRL_message,define_256_chars,"FLOW_CONTROL_UNDEFINED");

		 if (VI_ASRL_FLOW_NONE==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(Actual_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_NONE");
		}

		if (VI_ASRL_FLOW_XON_XOFF==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(Actual_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_XON_XOFF");
		}

        if (VI_ASRL_FLOW_RTS_CTS==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(Actual_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_RTS_CTS");
		}

		 if (VI_ASRL_FLOW_DTR_DSR==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(Actual_FLOW_CNTRL_message,define_256_chars,"VI_ASRL_FLOW_DTR_DSR");
		}





          if (pvt_VISA_Reply_Attribute!=Requested_FLOW_CONTROL)
		  {
		 
		     system("cls");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*  Non valid result from  ''pvt_adjust_FLOW_CONTROL''!   *\n");
	          printf("*                                                        *\n");
	          printf("*  The requested FLOW CONTROL =%s *\n",Requested_FLOW_CNTRL_message);
			  printf("*                                                        *\n");
	          printf("*  The actual FLOW CONTROL =%s  *\n",Actual_FLOW_CNTRL_message);
			  printf("*                                                        *\n");
			  printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	         //printf("%s\n",pvt_Bell_Array);//pvt_Bell_Array
	          printf("\n\n\n");
	         pvt_Acknowlege_Message();
		  }




   return Reply_Message;
 }





   unsigned char VISA_RS232_Manager::pvt_adjust_BAUD_rate(  ViAttrState   pvt_Requested_BAUD_rate )
   { 
	 unsigned char Reply_Message =0X00;    
    
     Has_COM_PORT_Been_Selected_yet();

	
     
	  if (0>VISA_Resorce_ID_Examination())
	  {
	     return 0X01;//Error code
	  }
 
	 
	 
	   pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_BAUD, pvt_Requested_BAUD_rate);
	   if (0>pvt_status)
		 {
		   viSetAttribute_Error_Message();//Display generic error message
		    return 0X02;//Error code
		  }


	   pvt_VISA_Reply_Attribute =0;
		pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_BAUD, &pvt_VISA_Reply_Attribute);  
		if (0>pvt_status)
		{
		 viGetAttribute_Error_Message();//Display generic error message
		 return 0X04;//Error code
		 }

		if (pvt_VISA_Reply_Attribute!=pvt_Requested_BAUD_rate)
		{

		     system("cls");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*  Non valid result from  ''pvt_adjust_BAUD_rate''!      *\n");
	          printf("*                                                        *\n");
	          printf("*  The requested BAUD rate=%i *\n",pvt_Requested_BAUD_rate);
			  printf("*                                                        *\n");
	          printf("*  The actual BAUD rate=%i   *\n",pvt_VISA_Reply_Attribute);
			  printf("*                                                        *\n");
			  printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	         printf("%s\n",pvt_Bell_Array);//pvt_Bell_Array
	          printf("\n\n\n");
	         pvt_Acknowlege_Message();

		}

      return Reply_Message;
   }


    unsigned char VISA_RS232_Manager::pvt_unsigned_char_array_to_char_array(unsigned char  Source_unsigned_char_array[], char Destination_char_array[], unsigned int Array_Length)
	 {
        unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_char_array[byte_index] = (char) Source_unsigned_char_array[byte_index];
		 }

        return reply_message;
	 }

    

    unsigned char VISA_RS232_Manager::pvt_char_array_to_unsigned_char_array(char Source_char_array[], unsigned char Destination_unsigned_char_array[], unsigned int Array_Length)
	{

		unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_unsigned_char_array[byte_index] = (unsigned char) Source_char_array[byte_index];
		 }

        return reply_message;
	}


	      
	
        
     void  VISA_RS232_Manager::viSetAttribute_Error_Message()
	{// Generic error message for SetAttribute_Error_Check
	
			  system("cls");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*         Non valid result from  ''viGetAttribute''      *\n");
	          printf("*                                                        *\n");
	          printf("*         VISA_RS232_Manager will now puke on you.       *\n");
			  printf("*                                                        *\n");
	          printf("*    Use ''Detect_VISA_Interfaces();'' to make           *\n");
			  printf("*    certain that the selected COM port is avalible!!!!  *\n");
			  printf("*                                                        *\n");
			  printf("*  SEE: ''Detect_VISA_Interfaces.h''                     *\n");
			  printf("*                                                        *\n");
			  printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("%s\n",pvt_Bell_Array);//pvt_Bell_Array
	          printf("\n\n\n");
	         pvt_Acknowlege_Message();
	}





	void  VISA_RS232_Manager::viGetAttribute_Error_Message()
	{// Generic error message for SetAttribute_Error_Check
		
			  system("cls");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*         Non valid result from  ''viGetAttribute''      *\n");
	          printf("*                                                        *\n");
	          printf("*           VISA_RS232_Manager will now puke on you.     *\n");
			  printf("*                                                        *\n");
	          printf("*    Use ''Detect_VISA_Interfaces();'' to make           *\n");
			  printf("* certain that the selected COM port is avalible!!!!     *\n");
			  printf("*                                                        *\n");
			  printf("*  SEE: ''Detect_VISA_Interfaces.h''                     *\n");
			  printf("*                                                        *\n");
			  printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("%s\n",pvt_Bell_Array);
	          printf("\n\n\n");
	         pvt_Acknowlege_Message();
	}





         
	   int  VISA_RS232_Manager::VISA_Resorce_ID_Examination()//ERROR TESTING
	   {
		//********************************************************************
	     //  This function is summoned when some attempts to use any of these *
	     // classes without initiliseing "pvt_VISA_Resorce_ID"                    *
	     //********************************************************************

		   if (-999999==pvt_VISA_Resorce_ID)//Original value is bogus
		   {
			system("cls");

	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*            pvt_VISA_Resorce_ID is not intialised!  *\n");
	          printf("*                                                        *\n");
	          printf("*           VISA_RS232_Manager will now puke on you.     *\n");
	          printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	         printf("%s\n",pvt_Bell_Array);
	          printf("\n\n\n");
	        pvt_Acknowlege_Message();
               
			return -1;//ERROR code

		   }
	   
        return +1;// OK test code

	   } //END   VISA_Resorce_ID_Examination *********************************



	   void VISA_RS232_Manager::pvt_RS232_Receive_Error_Message()
	 {
		   system("cls");
            printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*            RS232 RECEIVE FUNCTION PUKED                *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*        Exit now or death will visit your bedroom.      *\n");
			printf("*                                                        *\n");
	        printf("*           VISA_RS232_Manager will now puke on you.     *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n",pvt_Bell_Array);
	        printf("\n\n\n");
	       pvt_Acknowlege_Message();
	 }

      void VISA_RS232_Manager::pvt_RS232_Transmitt_Error_Message()
	 {
		   system("cls");
            printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*            RS232 TRANSMITT FUNCTION PUKED              *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*        Exit now or death will visit your bedroom.      *\n");
			printf("*                                                        *\n");
	        printf("*           VISA_RS232_Manager will now puke on you.     *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n",pvt_Bell_Array);
	        printf("\n\n\n");
	      pvt_Acknowlege_Message();
            
	 }






   public:

        // Class constructor
        VISA_RS232_Manager::VISA_RS232_Manager()//Initilise internal varibles
	   {
	    
		pvt_Bell_Array[0]=(char) 7;//Bell symbol
		pvt_Bell_Array[1]=(char) 7;//Bell symbol
		pvt_Bell_Array[2]=(char) 7;//Bell symbol
		pvt_Bell_Array[3]='\0';    //Null Terminator


		pvt_status=0;// this is the return value of the assignment statement
		
		pvt_VISA_Resorce_ID=-999999;//Bogus value

		pvt_ASRL_Number = 999;// bogus number
		

		
	






	   };//END constructor



		// Class desnstructor
        VISA_RS232_Manager::~VISA_RS232_Manager()//Initilise internal varibles
	   {
		   	

		     viClose (pvt_VISA_Resorce_ID);         //Close VISA session.
		     viClose (pvt_Default_Resource_Manager);         //Close VISA session.
		}
                
     //********************  SELECT 8 DATA Bits *********************************   
     ViAttrState VISA_RS232_Manager::ADJ_NUMBER_of_DATA_BITS(ViAttrState pvt_DATA_BITS_CPY)
	   {
		    Has_COM_PORT_Been_Selected_yet();


			

		 pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_DATA_BITS, pvt_DATA_BITS_CPY);

		   if (0>pvt_status)
		   {
		      viSetAttribute_Error_Message();//Display generic error message
			 return pvt_status;//Error code
		   }

           pvt_VISA_Reply_Attribute =0;
		   pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_DATA_BITS, &pvt_VISA_Reply_Attribute);
		   if (0>pvt_status)
		   {
		      viGetAttribute_Error_Message();//Display generic error message
		      return pvt_status;//Error code
		   }   

		 
		  

		   if (pvt_DATA_BITS_CPY!=pvt_VISA_Reply_Attribute)
		   {
			printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
			printf("*                                                        *\n");
			printf("*        ADJUST RS232 to 8 bits FUNCTION PUKED           *\n");
			printf("*                                                        *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n\n\n\n\n");

               pvt_Acknowlege_Message();
		   }


		return pvt_VISA_Reply_Attribute;//The reply function(viGetAttribute) is ERROR OGKW!


	   };
	 //********************  __________________________ *********************************   


       int VISA_RS232_Manager::Has_COM_PORT_Been_Selected_yet()
	   {
         if (200<pvt_ASRL_Number)//ERROR Detected.  Intial value set to 999
		 { 
			system("cls");
            printf("******************** ERROR ALERT!  ***********************\n");
			printf("*                                                        *\n");
	        printf("*                                                        *\n");
			printf("*   THE CORRECT COM NUMBER MUST BE SPECIFIED FIRST!!!!!  *\n");
			printf("*                                                        *\n");
	        printf("*                                                        *\n");
	        printf("*          You delivered an invalid value to:            *\n");
			printf("*              ADJ_VI_ATTR_ASRL_COM_number               *\n");
	        printf("*                                                        *\n");
			printf("*            Test for open COM ports with                *\n");
			printf("*         ''Detect_Avalible_VISA_Interfaces()''          *\n");
			printf("*                                                        *\n");
			printf("*                                                        *\n");
	        printf("*        VISA_RS232_Manager will now puke on you.        *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n",pvt_Bell_Array);
	        printf("\n\n\n");
	        pvt_Acknowlege_Message();
             return -1;

		 }
		 return 0;

	   }


	   int VISA_RS232_Manager::Detect_Avalible_VISA_Interfaces()
	   {
		 //****************** Varible Declaration Zone *************************
         // char Arrays
      
		 // VISA Varibles 
         static char instrDescriptor[VI_FIND_BUFLEN];
         static ViUInt32 Num_VISA_Resources;
         static ViFindList findList;
         static ViSession defaultRM, instr;
         static ViSession MY_Instument;
         static ViStatus pvt_status;
		 char   pvt_YES_NO;

		  FILE *VISA_interfaces_report_FILE_pntr;



		
	     printf("\n\n\n''Detect_Avalible_VISA_Interfaces'' summoned. \n\n Need to wait for up to 60seconds.\n\n\n\n");
	     Sleep(500);
   
		 /* First we will need to open the default resource manager. */
         pvt_status = viOpenDefaultRM (&defaultRM);
         if (pvt_status < VI_SUCCESS)
        {
          printf("******************** ERROR ALERT!  ***********************\n");
	      printf("*                                                        *\n");
	      printf("* Could not open a session to the VISA Resource Manager! *\n");
	      printf("*                                                        *\n");
	      printf("******************** ERROR ALERT!  ***********************\n");
	      printf("%s\n",pvt_Bell_Array);
	      printf("\n\n\n");
	      pvt_Acknowlege_Message();
          exit (EXIT_FAILURE);
         }  

         /*
         * Find all the VISA resources in our system and store the number of resources
         * in the system in numInstrs.  Notice the different query descriptions a
         * that are available.

           Interface         Expression
           --------------------------------------
           GPIB              "GPIB[0-9]*::?*INSTR"
           VXI               "VXI?*INSTR"
           GPIB-VXI          "GPIB-VXI?*INSTR"
           Any VXI           "?*VXI[0-9]*::?*INSTR"
           Serial            "ASRL[0-9]*::?*INSTR"
           PXI               "PXI?*INSTR"
           All instruments   "?*INSTR"
           All resources     "?*"  
           a*/


		 
     

    //***************************** OPEN DEFAULT VISA OBJECT **********************************

    pvt_status = viFindRsrc (defaultRM, "?*", &findList, &Num_VISA_Resources, instrDescriptor);
    if (pvt_status < VI_SUCCESS)
    {

	   printf("******************** ERROR ALERT!  ***********************\n");
	   printf("*                                                        *\n");
	   printf("*  A default VISA Resource Manager can not be opened     *\n");
	   printf("*                                                        *\n");
	   printf("*            VISA Resource Manager puked!                *\n");
	   printf("*                                                        *\n");
	   printf("******************** ERROR ALERT!  ***********************\n");
	   printf("%s\n",pvt_Bell_Array);
	   printf("\n\n\n");
	 pvt_Acknowlege_Message();
	 
      viClose (defaultRM);
	  return 0;

   }
   //***************************** OPEN DEFAULT VISA OBJECT **********************************
   
	// File_Open_Error = fopen_s(&pvt_Engineering_file_writer,Reserved_File_Name_Array, "w");

	 pvt_File_Open_Error = fopen_s(&VISA_interfaces_report_FILE_pntr,"Avalible_VISA_Interfaces_Report.txt", "w+"); 


	 if ((0!=pvt_File_Open_Error)||(NULL==VISA_interfaces_report_FILE_pntr))
	 {
		  pvt_YES_NO='n';
		  while ('y'!=pvt_YES_NO)
		  {
		   printf("\n\n\n");
           printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*  ''Detect_Avalible_VISA_Interfaces'' puked on you.     *\n");
	       printf("*                                                        *\n");
		   printf("* Can not open ''Avalible_VISA_Interfaces_Report.txt''   *\n");
		   printf("*                                                        *\n");
		   printf("*                                                        *\n");
		   printf("*   You might need to restart your machine to purge the  *\n");
		   printf("* abandoned file pointers.                               *\n");
		   printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n", pvt_Bell_Array);
	       printf("\n\n\n");
	       printf("Tap 'y' to acknowlege this message.");
		   pvt_YES_NO = getchar();
		  }
		  return -1;//Error

	 };//END if ((0!=pvt_File_Open_Error)||(NULL==VISA_interfaces_report_FILE_pntr))

	 fclose(VISA_interfaces_report_FILE_pntr);


	 //********************************** FIND ANY INTERFACE  **********************************
	 //
     //  This section finds all of the VISA resources.  This is important since some ports do not
     // have a predefined protocol. An example of this is the RS 232 serial port. These ports do
     // not respond to an "*IDN?\n" request if the protocol if the protocol adjustments are not
     // set proporly. 
 
 
     Num_VISA_Resources++;//Accomadates the next while statement
  
     while (--Num_VISA_Resources) /* stay in this loop until we find all instruments */
    {
	
      if (pvt_status < VI_SUCCESS) 
      {   /* did we find the next resource? */
		  pvt_YES_NO='n';
		  
           printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*            VISA Resource Manager puked!                *\n");
	       printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n", pvt_Bell_Array);
	       pvt_Acknowlege_Message();
         
           viClose (defaultRM);
	  
         
      } 

	  fopen_s(&VISA_interfaces_report_FILE_pntr,"Avalible_VISA_Interfaces_Report.txt", "a");

      fprintf(VISA_interfaces_report_FILE_pntr,"VISA Interface(%i)=%s\n",Num_VISA_Resources,instrDescriptor);
	  printf("VISA Interface(%i)=%s\n",Num_VISA_Resources,instrDescriptor);
	  fclose(VISA_interfaces_report_FILE_pntr);


	 
	 //Resource_ID_Num++;
    
      pvt_status = viFindNext (findList, instrDescriptor);  /* find next desriptor */ 
   }    /* end while */
   //********************************END FIND ANY INTERFACE ******************************/

	 system("Avalible_VISA_Interfaces_Report.txt");

       
 
         return 0;
       }//int VISA_RS232_Manager::Detect_Avalible_VISA_Interfaces()


	     int VISA_RS232_Manager::ADJ_COM_ID_number(unsigned int  COM_ID)
	   {

            
             char     ASRL_message[define_256_chars];
             ViStatus Open_VI_pvt_status;
			 char   pvt_YES_NO;


           pvt_ASRL_Number = COM_ID;//used in display parameters;
           viOpenDefaultRM (&pvt_Default_Resource_Manager);   
		   sprintf_s(ASRL_message,define_256_chars,"ASRL%i::INSTR\0",COM_ID);

           Open_VI_pvt_status = viOpen (pvt_Default_Resource_Manager, ASRL_message, VI_NULL,VI_NULL, &pvt_VISA_Resorce_ID); // 

			if (0!=Open_VI_pvt_status)
			{

		      pvt_YES_NO='n';
		      while ('y'!=pvt_YES_NO)
		      {

               system("cls");
               printf("******************** ERROR ALERT!  ***********************\n");
	           printf("*                                                        *\n");
	           printf("*          You delivered an invalid value to:            *\n");
			   printf("*              ADJ_VI_ATTR_ASRL_COM_number               *\n");
	           printf("*                                                        *\n");
			   printf("*            Test for open COM ports with                *\n");
			   printf("*         ''Detect_Avalible_VISA_Interfaces()''          *\n");
			   printf("*                                                        *\n");
			   printf("*                                                        *\n");
			   printf("*     Typical COM numbers are 16,1, and 5                *\n");
			   printf("*                                                        *\n");
	           printf("*         VISA_RS232_Manager will now puke on you.       *\n");
	           printf("*                                                        *\n");
	           printf("******************** ERROR ALERT!  ***********************\n");
	           printf("%s\n",pvt_Bell_Array);
	           printf("\n\n\n");
	           printf("Tap any key to continue......");
			   pvt_YES_NO = getchar();
			  }
             return -1;
			}
		    RS232_DEFAULT_SETTINGS( );

             return 0;


		 };


         ViStatus VISA_RS232_Manager::Transmitt_BYTE_array_to_RS232(unsigned char BYTE_array[], unsigned long Desired_Number_of_Bytes, unsigned long &Actual_Write_Count )
	     {
			Has_COM_PORT_Been_Selected_yet();

            static ViStatus RS232_pvt_status;       //Returns pvt_status from VISA functions 0 if OK
	  
			
            RS232_pvt_status   = viWrite (pvt_VISA_Resorce_ID, (ViBuf)BYTE_array, Desired_Number_of_Bytes, &Actual_Write_Count);//VI_pvt_status


			if (0!=RS232_pvt_status)
			{
			   pvt_RS232_Transmitt_Error_Message();//Error message
			}



			return RS232_pvt_status;
	           	
		 };//END  ViStatus VISA_RS232_Manager::Transmitt_BYTE_array_to_RS232



        ViStatus VISA_RS232_Manager::Transmitt_char_array_to_RS232( char char_array[], unsigned long Desired_Number_of_Bytes, unsigned long &Actual_Write_Count )
	     {
			Has_COM_PORT_Been_Selected_yet();

            static ViStatus RS232_pvt_status;       //Returns pvt_status from VISA functions 0 if OK

			unsigned char BYTE_array[500];

			pvt_char_array_to_unsigned_char_array(char_array, BYTE_array, ((unsigned int)Desired_Number_of_Bytes));
	  
			
            RS232_pvt_status   = viWrite (pvt_VISA_Resorce_ID, (ViBuf)BYTE_array, Desired_Number_of_Bytes, &Actual_Write_Count);//VI_pvt_status

			if (0!=RS232_pvt_status)
			{
			   pvt_RS232_Transmitt_Error_Message();//Error message
			}

        

			return RS232_pvt_status;
	           	
		 };//END  ViStatus VISA_RS232_Manager::Transmitt_BYTE_array_to_RS232  




         ViStatus VISA_RS232_Manager::Receive_BYTE_array_from_RS232(unsigned char BYTE_array[], unsigned long &Number_of_Bytes )
		 {
          	
            unsigned long MAX_read_count;                // This is the number of bytes written to RS232
            static        ViStatus RS232_pvt_status;       //Returns pvt_status from VISA functions 0 if OK

			Has_COM_PORT_Been_Selected_yet();


			MAX_read_count = Number_of_Bytes;
			if (500>Number_of_Bytes)
			{

			  MAX_read_count = 500;
			                       //   There is a trap here.  If you assign an unsufficiently large number for
			                       // the maximum expected bytes, then you might lose some data!
			}

            RS232_pvt_status = viRead (pvt_VISA_Resorce_ID, (ViBuf)BYTE_array, MAX_read_count, &Number_of_Bytes);

		
           return pvt_status;
		 }

		  ViStatus VISA_RS232_Manager::Receive_char_array_from_RS232( char char_array[], unsigned long &Number_of_Bytes )
		 {	
            unsigned long MAX_read_count;                // This is the number of bytes written to RS232
            static        ViStatus RS232_pvt_status;       //Returns pvt_status from VISA functions 0 if OK
			Has_COM_PORT_Been_Selected_yet();
			
			
			MAX_read_count = Number_of_Bytes;
			if (500>Number_of_Bytes)
			{

			  MAX_read_count = 500;
			                       //   There is a trap here.  If you assign an unsufficiently large number for
			                       // the maximum expected bytes, then you might lose some data!
			}



			unsigned char BYTE_array[500];

            RS232_pvt_status = viRead (pvt_VISA_Resorce_ID, (ViBuf)BYTE_array, MAX_read_count, &Number_of_Bytes);

			
			if (0!=RS232_pvt_status)
			{
			   pvt_RS232_Receive_Error_Message();//Error message
			}

			pvt_unsigned_char_array_to_char_array(BYTE_array, char_array,  Number_of_Bytes);
		
           return RS232_pvt_status;
		 }




	   //*************************ADJ_TIME_OUT_milliseconds*********************************

	   int VISA_RS232_Manager::ADJ_TIME_OUT_milliseconds(unsigned long  milli_seconds)
	   {
		    char   pvt_YES_NO;

		   Has_COM_PORT_Been_Selected_yet();// Sanity check 

		   if (0>VISA_Resorce_ID_Examination())
		   {
		    return -1;//Error code
		   }

            
		   if ((0>=milli_seconds)||(15000<milli_seconds))//>15 seconds=ERROR
		   {
			  system("cls");
              printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*          You delivered an invalid value to:            *\n");
			  printf("*                 ADJ_TIME_OUT_milliseconds              *\n");
	          printf("*                                                        *\n");
			  printf("*          The permitted value range is:                 *\n");
			  printf("*                                                        *\n");
			  printf("*              0<milli_seconds<15000                     *\n");
			  printf("*                                                        *\n");
	          printf("*           VISA_RS232_Manager will now puke on you.     *\n");
	          printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("%s\n",pvt_Bell_Array);

		      printf("\n\n\n");
		     
			  pvt_YES_NO='n';
		      while ('y'!=pvt_YES_NO)
		      {
	           printf("Tap any key to acknowlege this message......");
			   getchar();
		      }
	       
			return -1;//Return an error message

		   };//END  if ((0>=milli_seconds)||(15000<milli_seconds))//>15 seconds=ERROR


		   
	       pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_TMO_VALUE, milli_seconds);

		   if (0>pvt_status)
		   {
		    viSetAttribute_Error_Message();//Display generic error message
		    return pvt_status;//Error code
		   }

           pvt_VISA_Reply_Attribute =0;
		   pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_TMO_VALUE, &pvt_VISA_Reply_Attribute);

		   if (0>pvt_status)
		   {
		    viGetAttribute_Error_Message();//Display generic error message
		    return pvt_status;//Error code
		   }


          


           
		   if ((unsigned long)pvt_VISA_Reply_Attribute != milli_seconds )//>15 seconds=ERROR
		   {
			  system("cls");
              printf("******************** ERROR ALERT!  ***********************\n");
	          printf("*                                                        *\n");
	          printf("*  The actual VISA value of time out does not agree      *\n");
			  printf("*   with the requested RS232 time out   value!!          *\n");
	          printf("*                                                        *\n");
			  printf("*    ACTUAL ''TIME OUT''VALUE =%i     *\n",pvt_VISA_Reply_Attribute);
			  printf("*                                                        *\n");
			  printf("* REQUESTED ''TIME OUT''VALUE =%i     *\n",milli_seconds);
			  printf("*                                                        *\n");
	          printf("*           VISA_RS232_Manager will now puke on you.     *\n");
	          printf("*                                                        *\n");
	          printf("******************** ERROR ALERT!  ***********************\n");
	          printf("%s\n",pvt_Bell_Array);

		      printf("\n\n\n");
		     
			  pvt_YES_NO='n';
		      while ('y'!=pvt_YES_NO)
		      {
	           printf("Tap any key to acknowlege this message......");
			   getchar();
		      }
	       
			return -1;//Return an error message

		   };//END  if ((0>=milli_seconds)||(15000<milli_seconds))//>15 seconds=ERROR






		   return pvt_VISA_Reply_Attribute;


	   };//END VISA_RS232_Manager::ADJ_TIME_OUT_milliseconds(unsigned long  milli_seconds)
	   //*************************ADJ_TIME_OUT_milliseconds*********************************




	    unsigned char  VISA_RS232_Manager::ADJ_BAUD_to_2400(void)
	   {
		    unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 2400;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		   
		  return Reply_message;// 
	   }



	   unsigned char  VISA_RS232_Manager::ADJ_BAUD_to_3600(void)
	   {
		  unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 3600;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		   
		  return Reply_message;// 
	   }



	   
	   unsigned char VISA_RS232_Manager::ADJ_BAUD_to_4800(void)
	   {
		   unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 4800;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		   
		  return Reply_message;// 
	   }



	   unsigned char VISA_RS232_Manager::ADJ_BAUD_to_9600(void)
	   {
		    unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 9600;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		   
		  return Reply_message;// 
	   }




      unsigned char VISA_RS232_Manager::ADJ_BAUD_to_19200(void)
	   {
		  unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 19200;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		   
		  return Reply_message;// 
		  
	   }


	   unsigned char  VISA_RS232_Manager::ADJ_BAUD_to_38400(void)
	   {
		  unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 38400;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		   
		  return Reply_message;// 
	
	   }



         unsigned char  VISA_RS232_Manager::ADJ_BAUD_to_57600(void)
	   {
		  unsigned char Reply_message;

          ViAttrState  Requested_BAUD_rate = 57600;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );
		  
		   return Reply_message;// 
	   }


       unsigned char VISA_RS232_Manager::ADJ_BAUD_to_115200(void)
	   {
		  unsigned char Reply_message=0X00;

          ViAttrState  Requested_BAUD_rate = 115200;
          
		  Reply_message = pvt_adjust_BAUD_rate( Requested_BAUD_rate );

		  
		   return Reply_message;// 
	   }





	   //***********************ADJ_VI_ATTR_ASRL_FLOW_CNTRL*********************************

	   unsigned char  VISA_RS232_Manager::ADJ_FLOW_CNTRL_NONE( )
	   {

		 unsigned char Reply_Message;

		 ViAttrState VISA_FLOW_CONTROL=VI_ASRL_FLOW_NONE;

		 Reply_Message = pvt_adjust_FLOW_CONTROL(  VISA_FLOW_CONTROL );

		
         return Reply_Message;

	   };
	  


	   unsigned char  VISA_RS232_Manager::ADJ_FLOW_CNTRL_XON_XOFF( )
	   {
		  
		 unsigned char Reply_Message;

		 ViAttrState VISA_FLOW_CONTROL=VI_ASRL_FLOW_XON_XOFF;

		 Reply_Message = pvt_adjust_FLOW_CONTROL(  VISA_FLOW_CONTROL );
		 
		 getchar();
		 
         return Reply_Message;


	   };
	   
	 


	   unsigned char VISA_RS232_Manager::ADJ_FLOW_CNTRL_RTS_CTS( )
	   {
		 unsigned char Reply_Message;

		 ViAttrState VISA_FLOW_CONTROL=VI_ASRL_FLOW_RTS_CTS;

		 Reply_Message = pvt_adjust_FLOW_CONTROL(  VISA_FLOW_CONTROL );
		  
		 
         return Reply_Message;

	   };




	  unsigned char VISA_RS232_Manager::ADJ_FLOW_CNTRL_DTR_DSR( )
	   {
		  unsigned char Reply_Message;

		 ViAttrState VISA_FLOW_CONTROL=VI_ASRL_FLOW_DTR_DSR;
		

		 Reply_Message = pvt_adjust_FLOW_CONTROL(  VISA_FLOW_CONTROL );
		
         return Reply_Message;

	   };


	   






     


      //*************************VI_ATTR_ASRL_STOP_BITS*********************************
	   int VISA_RS232_Manager::ADJ_STOP_BITS_ONE( )
	   {
		    char   pvt_YES_NO;
		   Has_COM_PORT_Been_Selected_yet();

		   if (0>VISA_Resorce_ID_Examination())
		   {
			return -1;//Error code
		   }

       
		  pvt_VISA_Request_Attribute = VI_ASRL_STOP_ONE;

		   
	        pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_STOP_BITS, pvt_VISA_Request_Attribute);

		  

		   if (0>pvt_status)
		   {
		      viSetAttribute_Error_Message();//Display generic error message
			 return pvt_status;//Error code
		   }

		 
		   pvt_VISA_Reply_Attribute =0;
		   pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_STOP_BITS, &pvt_VISA_Reply_Attribute);
		   if (0>pvt_status)
		   {
		      viGetAttribute_Error_Message();//Display generic error message
		      return pvt_status;//Error code
		   }



		     if (pvt_VISA_Request_Attribute!=pvt_VISA_Reply_Attribute)
		   {

			   system("cls");
               printf("******************** ERROR ALERT!  ***********************\n");
	           printf("*                                                        *\n");
			   printf("*         ''ADJ_STOP_BITS_ONE'' PUKED       *\n");
			   printf("*                                                        *\n");
			   printf("*      The requested value=%i*\n",pvt_VISA_Request_Attribute);
			   printf("*                                                        *\n");
			   printf("*      The actual value=%i*\n",pvt_VISA_Reply_Attribute);
			   printf("*                                                        *\n");
			   printf("*                                                        *\n");
	           printf("*         VISA_RS232_Manager will now puke on you.       *\n");
	           printf("*                                                        *\n");
	           printf("******************** ERROR ALERT!  ***********************\n");
	           printf("%s\n",pvt_Bell_Array);
	           printf("\n\n\n");
	           printf("Tap any key to continue......");
			   pvt_YES_NO = getchar();
		   }





		return pvt_VISA_Reply_Attribute;


	   };
	   //*************************VI_ATTR_ASRL_STOP_BITS*********************************




      //*************************VI_ATTR_ASRL_STOP_BITS*********************************
	   int VISA_RS232_Manager::ADJ_STOP_BITS_TWO( )
	   {
		   Has_COM_PORT_Been_Selected_yet();
		   char   pvt_YES_NO;

		   if (0>VISA_Resorce_ID_Examination())
		   {
			return -1;//Error code
		   }

       
		  pvt_VISA_Request_Attribute = VI_ASRL_STOP_TWO;

		   
	      pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_STOP_BITS, pvt_VISA_Request_Attribute);

		  

		   if (0>pvt_status)
		   {
		      viSetAttribute_Error_Message();//Display generic error message
			 return pvt_status;//Error code
		   }

		     pvt_VISA_Reply_Attribute =0;
		      pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_STOP_BITS, &pvt_VISA_Reply_Attribute);
		   if (0>pvt_status)
		   {
		      viGetAttribute_Error_Message();//Display generic error message
		      return pvt_status;//Error code
		   }



		     if (pvt_VISA_Request_Attribute!=pvt_VISA_Reply_Attribute)
		   {

			   system("cls");
               printf("******************** ERROR ALERT!  ***********************\n");
	           printf("*                                                        *\n");
			   printf("*         ''ADJ_STOP_BITS_ONE'' PUKED       *\n");
			   printf("*                                                        *\n");
			   printf("*      The requested value=%i*\n",pvt_VISA_Request_Attribute);
			   printf("*                                                        *\n");
			   printf("*      The actual value=%i*\n",pvt_VISA_Reply_Attribute);
			   printf("*                                                        *\n");
			   printf("*                                                        *\n");
	           printf("*         VISA_RS232_Manager will now puke on you.       *\n");
	           printf("*                                                        *\n");
	           printf("******************** ERROR ALERT!  ***********************\n");
	           printf("%s\n",pvt_Bell_Array);
	           printf("\n\n\n");
	           printf("Tap any key to continue......");
			   pvt_YES_NO = getchar();
		   }



		 

		return pvt_VISA_Reply_Attribute;


	   };
	   //*************************VI_ATTR_ASRL_STOP_BITS*********************************







	  
	   unsigned char VISA_RS232_Manager::ADJ_PARITY_NONE( )
	   {

		  ViAttrState Requested_PARITY = VI_ASRL_PAR_NONE;
		  return pvt_adjust_PARITY(     Requested_PARITY );

	   };
	  

	   unsigned char  VISA_RS232_Manager::ADJ_PARITY_ODD( )
	   {
		   ViAttrState Requested_PARITY = VI_ASRL_PAR_ODD;
		  return pvt_adjust_PARITY(     Requested_PARITY );

	   };
	

	    unsigned char VISA_RS232_Manager::ADJ_PARITY_EVEN( )
	   {
		  ViAttrState Requested_PARITY = VI_ASRL_PAR_EVEN;
		  return pvt_adjust_PARITY(     Requested_PARITY );
	   };
	   

	   unsigned char VISA_RS232_Manager::ADJ_PARITY_MARK( )
	   {
		  
          ViAttrState Requested_PARITY = VI_ASRL_PAR_MARK;
		  return pvt_adjust_PARITY(     Requested_PARITY );

	   };
	 

	   unsigned char  VISA_RS232_Manager::ADJ_PARITY_SPACE( )
	   { 
		       
          ViAttrState Requested_PARITY = VI_ASRL_PAR_SPACE;
		  return pvt_adjust_PARITY(     Requested_PARITY );

	   };
	  
















	  



	   //*************************VI_ATTR_TERMCHAR_EN*********************************

	   int VISA_RS232_Manager::ADJ_VI_ATTR_TERMCHAR_EN_TRUE( bool TRUE_FALSE )
	   {
		   Has_COM_PORT_Been_Selected_yet();

		    char   pvt_YES_NO;

		   ViAttrState Requested_VISA_TRUE_FALSE;

		    ViAttrState Actual_VISA_TRUE_FALSE;

		   if (0>VISA_Resorce_ID_Examination())
		   {
			return -1;//Error code
		   }

       

		   if (true==TRUE_FALSE)
		   {
              Requested_VISA_TRUE_FALSE = VI_TRUE;
	        }else
		    {
              Requested_VISA_TRUE_FALSE =  VI_FALSE;
		    }

	        pvt_status = viSetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_TERMCHAR_EN, Requested_VISA_TRUE_FALSE);

		  
		   if (0>pvt_status)
		   {
		      viSetAttribute_Error_Message();//Display generic error message
			 return pvt_status;//Error code
		   }

		  pvt_VISA_Reply_Attribute = 0;// Actual_VISA_TRUE_FALSE =0;
		   pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_TERMCHAR_EN, &pvt_VISA_Reply_Attribute);
		   if (0>pvt_status)
		   {
		      viGetAttribute_Error_Message();//Display generic error message
		      return pvt_status;//Error code
		   }

		   Actual_VISA_TRUE_FALSE = pvt_VISA_Reply_Attribute;
		   if (Requested_VISA_TRUE_FALSE!=Actual_VISA_TRUE_FALSE)
		   {

			   system("cls");
               printf("******************** ERROR ALERT!  ***********************\n");
	           printf("*                                                        *\n");
			   printf("*         TERMINATION ABLE AJUSTMENT REQUEST PUKED       *\n");
			   printf("*                                                        *\n");
			   printf("*      The requested value=%i*\n",Requested_VISA_TRUE_FALSE);
			   printf("*                                                        *\n");
			   printf("*      The actual value=%i*\n",Actual_VISA_TRUE_FALSE);
			   printf("*                                                        *\n");
			   printf("*                                                        *\n");
	           printf("*         VISA_RS232_Manager will now puke on you.       *\n");
	           printf("*                                                        *\n");
	           printf("******************** ERROR ALERT!  ***********************\n");
	           printf("%s\n",pvt_Bell_Array);
	           printf("\n\n\n");
	           printf("Tap any key to continue......");
			   pvt_YES_NO = getchar();
		   }

//		   strcpy_s(pvt_TERMINATION_display,define_256_chars,"TERMCHAR_EN_TRUE");


		 
		return pvt_VISA_Reply_Attribute;


	   };
	   //*************************VI_ATTR_TERMCHAR_EN*********************************











       //******************************* DEFAULT RS232 Settings **********************
	  //   I know that these settings will work with an Agilent 34970A
	  // data aquistion unit.  You need to manually check the hardware to ensure that
	  // these are correct.  There is no way from software to determine the correct
	  // values.


       void VISA_RS232_Manager::RS232_DEFAULT_SETTINGS( )

	  {
		  Has_COM_PORT_Been_Selected_yet();
          ADJ_TIME_OUT_milliseconds(12000);         //12 Second delay
		  ADJ_BAUD_to_57600();                       //Determined from hardware settings
		  ADJ_NUMBER_of_DATA_BITS(8) ;                              //NO CHOICE ON THIS other bit values obsolete
		  ADJ_FLOW_CNTRL_NONE( );
		  ADJ_STOP_BITS_ONE( );
          ADJ_PARITY_NONE();
          ADJ_VI_ATTR_TERMCHAR_EN_TRUE(false);

	  }

	  //******************************* DEFAULT RS232 Settings **********************



	  void VISA_RS232_Manager::DISPLAY_RS232_SETTINGS()
	  {

	   char pvt_FLOW_CONTROL_display[define_256_chars];//Used in display
	   char pvt_PARITY_display      [define_256_chars];//Used in display
	   char pvt_TERMINATION_display [define_256_chars];//Used in display
	   char pvt_STOP_BITS_display [define_256_chars];//Used in display
    
	   


         printf("\n\n\n");

	    printf("***************** RS232 SETTINGS ****************\n\n");

		//Display com port
        printf("ASRL COM ID             =%i\n\n",pvt_ASRL_Number);

	    //Display Timeout value.
		pvt_VISA_Reply_Attribute= 0;
        viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_TMO_VALUE, &pvt_VISA_Reply_Attribute);
        printf("TIME_OUT(milliseconds)  =%i\n\n",pvt_VISA_Reply_Attribute);


	    //Display BAUD Rate
		pvt_VISA_Reply_Attribute =0;
	    viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_BAUD, &pvt_VISA_Reply_Attribute);
	    printf("BAUD_RATE               =%i\n\n",pvt_VISA_Reply_Attribute);


		

	    //Display Number of bits

		pvt_VISA_Reply_Attribute =0;
		pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_DATA_BITS, &pvt_VISA_Reply_Attribute);
	    printf("NUMBER_of_BITS          =%i\n\n",pvt_VISA_Reply_Attribute);


	   //strcpy_s(pvt_FLOW_CONTROL_display,define_256_chars,"FLOW_CNTRL_NONE");
   
        


        //Display flow control
        pvt_VISA_Reply_Attribute =0;
		pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_FLOW_CNTRL, &pvt_VISA_Reply_Attribute);

		  strcpy_s(pvt_FLOW_CONTROL_display,define_256_chars,"FLOW_CONTROL_UNDEFINED");

		 if (VI_ASRL_FLOW_NONE==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_FLOW_CONTROL_display,define_256_chars,"VI_ASRL_FLOW_NONE");
		}

		if (VI_ASRL_FLOW_XON_XOFF==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_FLOW_CONTROL_display,define_256_chars,"VI_ASRL_FLOW_XON_XOFF");
		}

        if (VI_ASRL_FLOW_RTS_CTS==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_FLOW_CONTROL_display,define_256_chars,"VI_ASRL_FLOW_RTS_CTS");
		}

		 if (VI_ASRL_FLOW_DTR_DSR==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_FLOW_CONTROL_display,define_256_chars,"VI_ASRL_FLOW_DTR_DSR");
		}

	    

		printf("FLOW CONTROL            =%s\n\n",pvt_FLOW_CONTROL_display);

	    //Display stop bits
	
		 pvt_VISA_Reply_Attribute =0;
		 pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_STOP_BITS, &pvt_VISA_Reply_Attribute);

       



      	 if (VI_ASRL_STOP_ONE==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_STOP_BITS_display,define_256_chars,"VI_ASRL_STOP_ONE");
		}


		 if (VI_ASRL_STOP_ONE5==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_STOP_BITS_display,define_256_chars,"VI_ASRL_STOP_ONE5");
		}


		if (VI_ASRL_STOP_TWO==pvt_VISA_Reply_Attribute)
		{
            strcpy_s(pvt_STOP_BITS_display,define_256_chars,"VI_ASRL_STOP_TWO");
		}

		

		printf("STOP BITS               =%s\n\n",pvt_STOP_BITS_display);






		  
           pvt_VISA_Reply_Attribute =0;// Known initilisation
	    pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_ASRL_PARITY, &pvt_VISA_Reply_Attribute);

		
           if (VI_ASRL_PAR_NONE==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_PARITY_display,define_256_chars,"VI_ASRL_PAR_NONE");
		   }

		   
           if (VI_ASRL_PAR_ODD==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_PARITY_display,define_256_chars,"VI_ASRL_PAR_ODD");
		   }

		   
           if (VI_ASRL_PAR_EVEN==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_PARITY_display,define_256_chars,"VI_ASRL_PAR_EVEN");
		   }

		   
           if (VI_ASRL_PAR_MARK==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_PARITY_display,define_256_chars,"VI_ASRL_PAR_MARK");
		   }


		    if (VI_ASRL_PAR_SPACE==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_PARITY_display,define_256_chars,"VI_ASRL_PAR_SPACE");
		   }

        //Display parity
	    printf("PARITY                  =%s\n\n",pvt_PARITY_display);



		  pvt_VISA_Reply_Attribute = 0;// Actual_VISA_TRUE_FALSE =0;
		  pvt_status = viGetAttribute (pvt_VISA_Resorce_ID, VI_ATTR_TERMCHAR_EN, &pvt_VISA_Reply_Attribute);

		  

		    if (VI_TRUE==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_TERMINATION_display,define_256_chars,"VI_TRUE");
		   }

			  if (VI_FALSE==pvt_VISA_Reply_Attribute)
		   {
             strcpy_s(pvt_TERMINATION_display,define_256_chars,"VI_FALSE");
		   }




	    //Display termination enable
	    printf("TERMINATION_CHAR_ENABLE =%s\n\n",pvt_TERMINATION_display);

       

		printf("***************** ______________ ****************\n\n");


        

	    printf("\n\n\n");

	    pvt_Acknowlege_Message();

	  }
	
	  



};


#endif 