/*
* 
* 
* 
*  Last edit date April, 26, 2022.  
Microsoft transformed the compilers...again...Grrrr! 
Defining "_CRT_SECURE_NO_WARNINGS" no longer  neutalises the unpleasantness 
with the  "strcpy" function. 
* 
* 
* 
	The following is class that communicates with ETHERNET. This class is specifically
	designed for data aquisition. A class model was selected so that I can accomadate 
	many instruments with as little trouble as possible. 


 Reference Material:

	All of the refernce materila material that I found originated from web searches. 
  I have placed copies of my research in a folder named "Sockets_Reference_Material".
  These files are haphazardly organised as follows:
 
   
   1)Sockets_Reference_Material/MSN_WSAGetLastError/*

     This is a large list of error codes that "WSAGetLastError" reports. This is a
	 Microsoft web page.

    
   2)Sockets_Reference_Material/MSN_WSAStartup/*

     This is a large list of error codes that "MSN_WSAStartup" reports. This is a
	 Microsoft web page.

      
   3)Sockets_Reference_Material/Sockets_Reference_xx_Files/Sockets_Part_xx_MAIN_page.htm

      This is where you will find the bulk of your information on sockets.  The saved 
	  web pages (Sockets_Reference_xx_Files, xx=01,02,03,...12 ) are a local copy in the
	  event that you can not locate the orginal data on the web.

        
   4)Sockets_Reference_Material/setsocketopt_Timeout/*

      This appears to be older Microsoft reference material. This is a code sample that
	allows you to adjust the time that the function will wait for a send or recieve 
	before an error is reported.


  
	If you can not find a particular item that you want, then use the web to search for 
   individual items.For example, enter "SO_SNDTIMEO" and "setsockopt()" into a search engine
   and poof! mysterious monkey blather appears from Microsoft corporation. 



 TO DO:



 1) Place a verbose ON/OFF function.






*/

#ifndef _CRT_SECURE_NO_WARNINGS 
#define _CRT_SECURE_NO_WARNINGS
#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **    COMPILER WARNING FUNCTION DEACTIVATED                   *  \n")
#pragma message("\n **              January, 2, 2014                              *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")
#endif






/************* setsockopt  ERROR CODES ***********************************************
Error code:        Meaning: 
WSANOTINITIALISED  A successful WSAStartup call must occur before using this function.
 
WSAENETDOWN        The network subsystem has failed.
 
WSAEFAULT          The buffer pointed to by the optval parameter is not in a valid
                   part of the process address space or the optlen parameter is too small.
 
WSAEINPROGRESS     A blocking Windows Sockets 1.1 call is in progress, or the service
                   provider is still processing a callback function.
 
WSAEINVAL          The level parameter is not valid, or the information in the buffer 
                   pointed to by the optval parameter is not valid.
 
WSAENETRESET       The connection has timed out when SO_KEEPALIVE is set.
 
WSAENOPROTOOPT     The option is unknown or unsupported for the specified provider or
                   socket (see SO_GROUP_PRIORITY limitations).
 
WSAENOTCONN        The connection has been reset when SO_KEEPALIVE is set.
 
WSAENOTSOCK        The descriptor is not a socket.
 
 ************* setsockopt  ERROR CODES ************************************************/





#pragma comment(lib, "ws2_32.lib")


#ifndef _LAN_Socket_Ethernet_class_dot_h_
#define _LAN_Socket_Ethernet_class_dot_h_



#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **      _LAN_Socket_Ethernet_class_dot_h_                     *  \n")
#pragma message("\n **                January 21, 2014                            *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")


class LAN_Socket_Ethernet_class
{
   
    public:



   
    //******************* LAN_Socket_Ethernet_class Constructor****************** 
		LAN_Socket_Ethernet_class()
	{


      //************ Initialise Address to bogus value ******************
	  private_Ethernet_IP_Address[0]='\0';// All valid IP addresses have a length > 0 bytes
	                                      // The line terminator ('\0') at [0] means the length
	                                      // is zero. 
     


	  //*************** Initialise PORT ID to bogus value ******************
      private_PORT_ID = 0X000;/// This is known port that you must never use


      //********** Initialise TCP_UDP_designator to non expected value ******************
	  private_TCP_UDP_designator =0XFF;// I only expect 0X00 or 0X01. 


      //********** Initialise private_MAX_RECEIVE_latency_time_mS to a sane value ******************
      private_MAX_RECEIVE_latency_time_mS=500;// 0 mS means NO delay is expected, which is absurd.   


	  //********** Initialise private_MAX_SEND_latency_time_mS to a sane value ******************
      private_MAX_SEND_latency_time_mS=500;// 0 mS means NO delay is expected, which is absurd.   





      //********** Initialise private_ETHERNET_INIT_ERROR to error state ****************
	  private_ETHERNET_INIT_ERROR = 0XFFFF;//!=0 is error state. 

	

      private_Intialisation_Exam = 0XFF;




	  // Using MAKEWORD macro, Winsock version request 2.2

        private_wVersionRequested = MAKEWORD(2, 2);

 

        private_wsaerr = WSAStartup(private_wVersionRequested, &private_wsaData);

        if (private_wsaerr != 0)

		{

         /* Tell the user that we could not find a usable */
         /* WinSock DLL.*/

         printf("The Winsock dll not found! BOHICA!\n");
		 Sleep(1000);

		 private_REPORT_WSAStartup_ERROR(private_wsaerr);// Report MIcrosoft errors
        

         exit(0); 


		}

         else

		 {

           printf("A miracle has occured! The Winsock dll found!\n");
           printf("The status: %s.\n", private_wsaData.szSystemStatus);

		 }

 


      





       /* Confirm that the WinSock DLL supports 2.2.*/
       /* Note that if the DLL supports versions greater    */
       /* than 2.2 in addition to 2.2, it will still return */
       /* 2.2 in wVersion since that is the version we      */
       /* requested.                                        */

       if (LOBYTE(private_wsaData.wVersion) != 2 || HIBYTE(private_wsaData.wVersion) != 2 )

	   {

         /* Tell the user that we could not find a usable */
         /* WinSock DLL.*/

          printf("The dll does not support the Winsock version %u.%u!\n", LOBYTE(private_wsaData.wVersion),HIBYTE(private_wsaData.wVersion));

         WSACleanup();
		 Sleep(2000);

         exit(0); 

	   } 

       else

	   { 

        printf("The dll supports the Winsock version %u.%u!\n", LOBYTE(private_wsaData.wVersion),HIBYTE(private_wsaData.wVersion));
        printf("The highest version this dll can support: %u.%u\n", LOBYTE(private_wsaData.wHighVersion), HIBYTE(private_wsaData.wHighVersion));

	   } 

 

/* The next task... */



      










	};//  END LAN_Socket_Ethernet_class Constructor




    //******************* LAN_Socket_Ethernet_class Destructor ****************** 
	~LAN_Socket_Ethernet_class()
	{

		 WSACleanup();
	   closesocket(private_MAGIC_socket);

        WSACleanup();
 

	}// END LAN_Socket_Ethernet_class Destructor


	/*************************************  Transmitt_Data ********************************
	
      		  

    Error Code:              Interpretation:
    
	  0X00                   Function worked as expected.
	  0X01                   The conduit has not been initilised proporly
	  0X02                   "Number_of_Bytes" = 0.  Why do you want o send NO bytes?
	  0X04                   The number of requested bytes doe not equal the actual number of
	                         bytes that were transmitted.
      0X08                   The transmission time exceeded the value as specified by 
	                         "private_MAX_SEND_latency_time_mS"

	  
	 
      Varible Name:   Ausgang_Data_array

	  Interpretation: This is an array of bytes that you want to dispatch to the UDP or TCP
	                  conduit.
 
       Varible Name:   Number_of_Bytes

       Interpreation: The value that YOU furnish in the function summons is the number of
	                  bytes that YOU want to send to the UDP or TCP conduit.   

                      The value of "Number_of_Bytes" at the end of the function is the number
					  of bytes that were actually sent. 





	*********************************** _________________ ********************************/

	unsigned char Transmitt_Data( char Ausgang_Data_array[], int &Number_of_Bytes )
	{
        unsigned char error_message =0X00;
		int WSAGetLastError_ERROR_message;

          unsigned short INIT_reply;
     
		 
		 if (0X00!=private_Intialisation_Exam)
		 {
            INIT_reply = Generate_ETHERNET_conduit();//Test for ethernet Init  WTF_JHS
			private_Intialisation_Exam = 0X00;
			 printf("FORCED ETHERNET INIT from Transmitt!!!!\n");
		 }



       if (0X0000!=private_ETHERNET_INIT_ERROR)
	   {
	      Generate_ETHERNET_conduit();//Test for ethernet Init 
		   printf(" ERROR ALERT! ethernet conduit not initilised proporly !!!!\n");
         error_message = 0X01;// Error:  The conduit has not been initilised proporly
		 return error_message;
	   }



	   int bytesSent;


	bytesSent = send(private_MAGIC_socket, Ausgang_Data_array, Number_of_Bytes, 0);


      //****************** ERROR MESSAGE ***********************
      WSAGetLastError_ERROR_message = WSAGetLastError();
      if (0!=WSAGetLastError_ERROR_message)
	  {

       private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	   error_message = 0X02;/// WSA reported an error!
	  }
	  //****************** ______________ ***********************


      // printf("Client: send() - Bytes Sent: %ld\n", bytesSent);//DEBUGGERY MESSAGE


	   return error_message;
	};




   /*************************************  RECIEVE_Data ********************************
	
      		  

    Error Code:              Interpretation:
    
	  0X00                   Function worked as expected.
	  0X01                   The conduit has not been initilised proporly
	  0X02                   "Number_of_Bytes" = 0.  No bytes were recieved Error! Error!
      0X04                   The receive time exceeded the value as specified by 
	                         "private_MAX_RECEIVE_latency_time_mS"
	  
	 
      Varible Name:   Entganag_Data_array

	  Interpretation: This is an array of bytes that you want to dispatch to the UDP or TCP
	                  conduit.
 
       Varible Name:  Number_of_expected_bytes

       Interpreation: This is the maximum number of bytes that you want/expect from the 
	                  READ summons.  If you do not know what your expected number of bytes,
					  then place a large number here such as 500.

                      The value of "Number_of_Bytes" at the end of the function is the number
					  of bytes that were actually recieved. 



	*********************************** _________________ ********************************/




     unsigned char Receive_Data( char Entganag_Data_array[], int &Number_of_expected_bytes )
	{
        unsigned char error_message =0X00;
		int           bytesRecv;


		if (50>Number_of_expected_bytes)
		{
          Number_of_expected_bytes =100;
		}

       int WSAGetLastError_ERROR_message;

        
	    unsigned short INIT_reply;



		 
		 if (0X00!=private_Intialisation_Exam)
		 {
            INIT_reply = Generate_ETHERNET_conduit();//Test for ethernet Init  WTF_JHS
			private_Intialisation_Exam = 0X00;
			printf("FORCED INIT from RECIEVE!!!!\n");
		 }




	   //* Examine initilisation 
       if (0X0000!=private_ETHERNET_INIT_ERROR)
	   {
         error_message = 0X01;// Error:  The conduit has not been initilised proporly
		
		 printf(" ERROR ALERT! ethernet conduit not initilised proporly !!!!\n");
          return error_message;
		 
	   }



       bytesRecv = recv(private_MAGIC_socket, Entganag_Data_array, Number_of_expected_bytes, 0);

	 
	 

 
       //** Test for bytes recieved
	   if (0==bytesRecv)
	   {
		   error_message = error_message |0X02;// NO BYTES WERE RECIEVED
	   }


	   
       // *** Testes for recieve errors
	   if (-1==bytesRecv)
	   {
		   error_message = error_message |0X04;//  Recieve might have timed out 
		                                       
	   }

	   //WSAECONNRESET

	   // *** Testes for recieve errors
	   if (WSAECONNRESET==bytesRecv)
	   {
		   error_message = error_message |0X08;//  Recieve might have timed out 
		  
	   }
       

	   //**** REPORT RECIEVE ERROR *****************
	   if (0X00!=error_message)
	   {
		   return error_message;
	   }


         Entganag_Data_array[bytesRecv]='\0';// Apply NULL TERMINATION 

	     Number_of_expected_bytes = bytesRecv;

         //****************** ERROR MESSAGE ***********************
         WSAGetLastError_ERROR_message = WSAGetLastError();
         if (0!=WSAGetLastError_ERROR_message)
		 {

           private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	      error_message = 0X02;/// WSA reported an error!
		 }
	     //****************** ______________ ***********************

  


	   return error_message;
	};//END unsigned char Receive_Data( char Entganag_Data_array[], int &Number_of_expected_bytes )






 /*********************   Assign_IP_Address ***********************

//127.0.0.1

 The TCP and the UDP require a four byte address.   Typically, this
 is represented as an array of chars such as "127.0.0.1".  I want this
 represeted as an array of unsigned chars.


  So...
 
 127 => 0XEF => private_Ethernet_IP_Address[0]
 0   => 0X00 => private_Ethernet_IP_Address[1]
 0   => 0X00 => private_Ethernet_IP_Address[2]
 1   => 0X01 => private_Ethernet_IP_Address[3]


 ******************_____________________************************/



  void Assign_IP_Address( const char IP_ADDRESS[])
  {
   //************ CONTRACTOR DOES NOT EDIT THIS FUNCTION ***********************   

	
	  strcpy_s(private_Ethernet_IP_Address, sizeof private_Ethernet_IP_Address, IP_ADDRESS);

	 
   return;
   //************ CONTRACTOR DOES NOT EDIT THIS FUNCTION ***********************
  }; 





 /*********************  Assign_TCP_UDP_PORT_ID  *********************



  *********************  _____________________  **********************/

  void Assign_PORT_ID ( unsigned short PORT_ID )
  {

	  private_PORT_ID = PORT_ID;
  };






  /******************* Designate_UDP_protocol ***************************   

    If you want to use "UDP" protocol execute this function. 



    returns nothing
   ******************** Designate_UDP_protocol ***************************/


   void Designate_UDP_protocol(void)
   {
    private_TCP_UDP_designator =0X00;// UDP can be any value other than 0X00; 

   };




   /******************* Designate_TCP_protocol ***************************   

    If you want to use "UDP" protocol execute this function. 



    returns nothing
    ******************** Designate_TCP_protocol ***************************/

   void Designate_TCP_protocol(void)
   {
     private_TCP_UDP_designator =0X01;// TCP = 0X00; 
   };


   /***************** Adjust_SEND_Latency_mS **************************

		I only want to wait a finite amount of time for either a transmission or
	a recieve function to occur.  If this time allotment is exceeded, then I
	want an error reported.  The error is reported only when after an unsucessful
	transmission or an unsucessful recieve operation. 



   ***************** _____________________________ ***************************/

   void Adjust_SEND_Latency_mS(unsigned int milli_Seconds_of_Latency )
   {

	     private_MAX_SEND_latency_time_mS = milli_Seconds_of_Latency;

   };



   
   /***************** Adjust_RECEIVE_Latency_mS **************************

		I only want to wait a finite amount of time for either a transmission or
	a recieve function to occur.  If this time allotment is exceeded, then I
	want an error reported.  The error is reported only when after an unsucessful
	transmission or an unsucessful recieve operation. 



   ***************** _____________________________ ***************************/

   void Adjust_RECEIVE_Latency_mS(unsigned int milli_Seconds_of_Latency )
   {

	  private_MAX_RECEIVE_latency_time_mS= milli_Seconds_of_Latency;

   };





 /********************* Generate_ETHERNET_conduit ****************************


  The first that this function must is to test if the configuration 
 parameters have been adjusted to sane and rational values.  
 
   Error Code:     Interpretation:                         


   0X0001           private_Ethernet_IP_Address[30];=> INIT ERROR 

   0X0002           private_PORT_ID;                => INIT ERROR  

   0X0004           private_TCP_UDP_designator;     => INIT ERROR 

   0X0008           private_MAX_RECEIVE_latency_time_mS;    => INIT ERROR

   0X0010           SOCKET INITILIZATION ERROR  

   0X0020           SOCKET CONNECTION ERROR   
   
   0X0040           SOCKET OPTIONS SELECT ERROR  
   
   0X0080           private_MAX_RECEIVE_latency_time_mS;    => INIT ERROR 
   
	

   If two or more errors occur, then the errors are added. 
   
for example if "private_Ethernet_IP_Address" and "private_PORT_ID" are
not initialised, then the returend value is (0X0008)+(0X0008)=0X0009.



  If any of the  configuration parameters are not initilised then the
function immediately exits.  NO bogus conduit is created. 


 ********************* ___________________ *****************************/




   unsigned short Generate_ETHERNET_conduit()// Research the latin origins before you whine about vulgarities!
   {

	   private_Intialisation_Exam =0X00;
       private_ETHERNET_INIT_ERROR =0X0000;
	   int WSAGetLastError_ERROR_message;



	   //************ TEST private_Ethernet_IP_Address ****************
	    
       if ('\0' == private_Ethernet_IP_Address [0]) 
	   {
		    private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0001;
	   }
      
	  
       //************ _______________________________ ****************



	   //************ TEST  private_PORT_ID ****************

	   if (0X0000==private_PORT_ID)
	   {
         private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0002;
	   }
	   //************ _____________________ ****************




	   //************ TEST  private_TCP_UDP_designator ****************
	   if (0XFF==private_TCP_UDP_designator)
	   {
         private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0004;
	   }
	    //************ ______________________________ ****************


       //************ TEST  private_MAX_RECEIVE_latency_time_mS ****************
	   if (0==private_MAX_RECEIVE_latency_time_mS)
	   {
		   private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0008;
	   }
	   //************ _______________________________ ****************


       
	    //************ TEST  private_MAX_RECEIVE_latency_time_mS ****************
	   if (0==private_MAX_SEND_latency_time_mS)
	   {
		   private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0080;
	   }
	   //************ _______________________________ ****************

 



		//***************   SPECIFY UDP OR TCP PROTOCOL ***********************************
		if (0X00==private_TCP_UDP_designator)// UDP is selected 
		{


         // Call the socket function and return its value to the m_socket variable.
         // For this application, use the Internet address family, streaming sockets, and
         // the UDP/IP protocol.
         // using AF_INET family, TCP socket type and protocol of the AF_INET - IPv4

         private_MAGIC_socket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
		}else
		{
         // Call the socket function and return its value to the m_socket variable.
         // For this application, use the Internet address family, streaming sockets, and
         // the TCP/IP protocol.
         // using AF_INET family, TCP socket type and protocol of the AF_INET - IPv4

         private_MAGIC_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
		}

		//***************   __________________________ ***********************************







       

		/********************* SOCKET ERROR CODES ****************************************************************

           Error code:                     Interpretiation:
 
           WSANOTINITIALISED                A successful   WSAStartup() call must occur before using this function.
 
           WSAENETDOWN                      The network subsystem or the associated service provider has failed.
 
           WSAEAFNOSUPPORT                  The specified address family is not supported.
 
           WSAEINPROGRESS                   A blocking Windows Sockets 1.1 call is in progress, or the service provider
		                                    is still processing a callback function.
 
		   WSAEMFILE                        No more socket descriptors are available.
 
           WSAENOBUFS                       No buffer space is available. The socket cannot be created.
 
           WSAEPROTONOSUPPORT               The specified protocol is not supported.
 
           WSAEPROTOTYPE                    The specified protocol is the wrong type for this socket.
 
           WSAESOCKTNOSUPPORT               The specified socket type is not supported in this address family.
 



        ********************* ____________________ *****************************************************************/





      //****************** ERROR MESSAGE ***********************
      WSAGetLastError_ERROR_message = WSAGetLastError();
      if (0!=WSAGetLastError_ERROR_message)
	  {

       private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	   //error_message = 0X02;/// WSA reported an error!
	  }
	  //****************** ______________ ***********************










         // ************************  ERROR CHECK THE CLIENT SOCKET  *************************
          if (private_MAGIC_socket == INVALID_SOCKET)

		  {


            printf("SOCKET INITILIZATION ERROR CODE: %ld\n", WSAGetLastError());
			  
            WSACleanup();

		    private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0010;


           //Sleep(2000);

         
		  }else

		  {

            printf("socket() is OK!\n");

		  }
		  // ************************  ______________________________ *************************


      //****************** ERROR MESSAGE ***********************
      WSAGetLastError_ERROR_message = WSAGetLastError();
      if (0!=WSAGetLastError_ERROR_message)
	  {

       private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	   //error_message = 0X02;/// WSA reported an error!
	  }
	  //****************** ______________ ***********************






        //*****************  CREATE THE MAGICAL SOCKET STRUCTURE *******************************

 
        private_clientService.sin_family = AF_INET;

        private_clientService.sin_addr.s_addr = inet_addr(private_Ethernet_IP_Address);

        private_clientService.sin_port = htons(private_PORT_ID);
 
        //*****************  ____________________________________ *******************************




		
           /************* setsockopt  ERROR CODES ***********************************************
           Error code:        Meaning: 
           WSANOTINITIALISED  A successful WSAStartup call must occur before using this function.
 
           WSAENETDOWN        The network subsystem has failed.
 
           WSAEFAULT          The buffer pointed to by the optval parameter is not in a valid
                              part of the process address space or the optlen parameter is too small.
 
           WSAEINPROGRESS     A blocking Windows Sockets 1.1 call is in progress, or the service
                              provider is still processing a callback function.
 
           WSAEINVAL          The level parameter is not valid, or the information in the buffer 
                              pointed to by the optval parameter is not valid.
 
           WSAENETRESET       The connection has timed out when SO_KEEPALIVE is set.
 
           WSAENOPROTOOPT     The option is unknown or unsupported for the specified provider or
                              socket (see SO_GROUP_PRIORITY limitations).
 
           WSAENOTCONN        The connection has been reset when SO_KEEPALIVE is set.
 
           WSAENOTSOCK        The descriptor is not a socket.
 
           ************* setsockopt  ERROR CODES ************************************************/





            //int timeout = TIMEOUT_VALUE;
			//int err;
			//SOCKET s;

             private_wsaerr = setsockopt(    private_MAGIC_socket, SOL_SOCKET,SO_RCVTIMEO  ,(char *)&private_MAX_RECEIVE_latency_time_mS,sizeof(private_MAX_RECEIVE_latency_time_mS));




		
		
         // ************************  REPORT setsockopt  ERROR CODES  *************************
          if (0 != private_wsaerr)

		  {


            printf(" ''setsockopt'' ERROR CODE: %ld\n", WSAGetLastError());
			  
            WSACleanup();

		    private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0020;


           //Sleep(2000);

        

		  }else

		  {

            printf(" ''setsockopt'' RECIEVE  selections are OK!\n");

		  }
		  // ************************  ______________________________ *************************


		 //****************** ERROR MESSAGE ***********************
         WSAGetLastError_ERROR_message = WSAGetLastError();
         if (0!=WSAGetLastError_ERROR_message)
		 {

           private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	   
		 }
	     //****************** ______________ ***********************




		    private_wsaerr = setsockopt(    private_MAGIC_socket, SOL_SOCKET,SO_SNDTIMEO   ,(char *)&private_MAX_SEND_latency_time_mS,sizeof(private_MAX_RECEIVE_latency_time_mS));




		
		
         // ************************  REPORT setsockopt  ERROR CODES  *************************
          if (0 != private_wsaerr)

		  {


            printf(" ''setsockopt'' ERROR CODE: %ld\n", WSAGetLastError());
			  
            WSACleanup();

		    private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0020;


           //Sleep(2000);

        

		  }else

		  {

            printf(" ''setsockopt'' SEND     selections are OK!\n");

		  }
		  // ************************  ______________________________ *************************

          //****************** ERROR MESSAGE ***********************
         WSAGetLastError_ERROR_message = WSAGetLastError();
         if (0!=WSAGetLastError_ERROR_message)
		 {

           private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	   
		 }
	     //****************** ______________ ***********************


       //************************************** ESTABLISH CONNECTION ***********************************   
       if (connect(private_MAGIC_socket, (SOCKADDR*)&private_clientService, sizeof(private_clientService)) == SOCKET_ERROR)

	   {

          printf("Client: connect() - Failed to connect.\n");

		  //****************** ERROR MESSAGE ***********************
         WSAGetLastError_ERROR_message = WSAGetLastError();
         if (0!=WSAGetLastError_ERROR_message)
		 {

           private_REPORT_WSAGetLastError_ERROR( WSAGetLastError_ERROR_message );

	   
		 }
	     //****************** ______________ ***********************

		 
		   private_ETHERNET_INIT_ERROR = private_ETHERNET_INIT_ERROR | 0X0040;

		  printf("SOCKET INITILIZATION ERROR CODE: %ld\n", WSAGetLastError());
			  
          WSACleanup();



          

	   }else
	   {
		    printf("Client: connect() - Sucessful!\n");
	   }
	   //************************************** ________________________ ***********************************   



      /*

		I have emerically determined that some sort of initial trannsmitt is
	necessary to initilaise the recieve function. I have made no effort to 
	determine why this is so. 


      */



	    //************ Initilise UDP protocol ****************
	   if (0X00==private_TCP_UDP_designator)
	   {
        
		   int Number_of_Bytes =1;
		   char Entganag_Data_array[500]={'*'};
         

         Transmitt_Data (Entganag_Data_array,Number_of_Bytes);

	   }
	    //************ ______________________ ****************



	   if (0X0000!=private_ETHERNET_INIT_ERROR)
	   {
            printf("''Generate_ETHERNET_conduit'' reports an error code of %i",private_ETHERNET_INIT_ERROR);
			

	   }





     return private_ETHERNET_INIT_ERROR;
      
   }


   /*************  Obliterate_Conduit *********************

    This function destroys all memories associated with the
	varibles that were ever used ( or might have been used)
	or  allocated with any  function(s) that in
	"class LAN_Socket_Ethernet_class".  This function restores the computer
	to the condtions that existed before  when  the
	"LAN_Socket_Ethernet_class()" constructor was invoked.




   *************  _________________ **********************/

    void Obliterate_Conduit( void)
    {

	  //************ Initialise Address to bogus value ******************
	  private_Ethernet_IP_Address[0]='\0';
     


	  //*************** Initialise PORT ID to bogus value ******************
      private_PORT_ID = 0X000;/// This is known port that you must never use


      //********** Initialise TCP_UDP_designator to non expected value ******************
	  private_TCP_UDP_designator =0XFF;// I only expect 0X00 or 0X01. 


      //********** Initialise private_MAX_RECEIVE_latency_time_mS to a bogus value ******************
      private_MAX_RECEIVE_latency_time_mS=0;// means NO delay is expected, which is absurd.   


      //********** Initialise private_ETHERNET_INIT_ERROR to error state ****************
	  private_ETHERNET_INIT_ERROR = 0XFFFF;//!=0 is error state. 

     
	   //*****  MAGICAL SOCKETS FUNCTIONS **************
	   WSACleanup();
	   closesocket(private_MAGIC_socket);
	   //*****  ________________________ **************




         
     return;//Nothing
    };




    
    
	private:


	char            private_Ethernet_IP_Address[30];     // This is the IP address for example "127.0.0.1"
    unsigned char   private_TCP_UDP_designator;          // Internal flag varible 0X00 if UDP, !=0X00 if TCP
 
    unsigned short  private_PORT_ID;                     // PORT ID number examples: 5559 or 3000
	unsigned short  private_ETHERNET_INIT_ERROR;         // Test for propor initilisation of TCP UDP conduit 0X00 if OK

	unsigned int    private_MAX_RECEIVE_latency_time_mS; // Time in milliseconds before "TIME_OUT" error  occurrs
		
	unsigned int    private_MAX_SEND_latency_time_mS;    // Time in milliseconds before "TIME_OUT" error  occurrs

	WORD            private_wVersionRequested;           // Reports the version of sockets that are avalible
                                                         // defined in "WINSOCK.h"

    WSADATA         private_wsaData;                     // Another magical sockets varible OOOGA! BOOGA!
	                                                     // defined in "WINSOCK.h"

    int             private_wsaerr;                      // Another magical sockets varible Unga Bunga
                                                         // defined in "WINSOCK.h"

	SOCKET          private_MAGIC_socket;                // Socket object. Plug?
                                                         // defined in "WINSOCK.h"

	sockaddr_in     private_clientService;               // Socket address more microsoft magic.
	                                                     // defined in "WINSOCK.h"
	
	//WSAGetLastError 

	unsigned char    private_Intialisation_Exam;        // Want to test if the conduit is initalised proporly before
	                                                    // A "transmitt" or "recieve"
	

	void private_REPORT_WSAGetLastError_ERROR(int WSAGetLastError_ERROR_message )
	{
		

         printf("\n\n\n\n");
         printf("*************** ERROR ALERT ****************************\n");
	     printf("*  private_REPORT_WSAGetLastError_ERROR results....    *\n");
		 printf("*  For more information, search the comments in        *\n");	
	     printf("*   :''private_REPORT_WSAGetLastError_ERROR''          *\n");
		 printf("*  I have reorganised the original Microsoft           *\n"); 
		 printf("* documentation in the comments                        *\n");
		 printf("*  in the function definition.   Use the ''cntrl F''   *\n");
	     printf("* funnction with the reported error.                   *\n");
		 printf("*************** ERROR ALERT **************************** \n\n\n\n");



		 /*
         WSA_INVALID_HANDLE 
         6 
         Specified event object handle is invalid. 
         An application attempts to use an event object, but the specified handle
		 is not valid. Note that this error is returned by the operating system, 
		 so the error number may change in future releases of Windows.
		 */	 
         if(6==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_INVALID_HANDLE'' \n");
		 }
         




		 /*
         WSA_NOT_ENOUGH_MEMORY 
         8 
         Insufficient memory available. 
         An application used a Windows Sockets function that directly maps to a 
		 Windows function. The Windows function is indicating a lack of required
		 memory resources. Note that this error is returned by the operating system,
		 so the error number may change in future releases of Windows.
         */		 
         if(8==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_NOT_ENOUGH_MEMORY'' \n");
		 }







		 /* 
         WSA_INVALID_PARAMETER 
         87 
         One or more parameters are invalid. 
         An application used a Windows Sockets function which directly maps to a
		 Windowsfunction. The Windows function is indicating a problem with one 
		 or more parameters. Note that this error is returned by the operating 
		 system, so the error number may change in future releases of Windows.
         */		 
         if(87==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_INVALID_PARAMETER'' \n");
		 }








		 /*
         WSA_OPERATION_ABORTED 
         995 
         Overlapped operation aborted. 
         An overlapped operation was canceled due to the closure of the socket, 
		 or the execution of the SIO_FLUSH command in WSAIoctl. Note that this 
		 error is returned by the operating system, so the error number may 
		 change in future releases of Windows.
		 */		 
         if(995==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_OPERATION_ABORTED'' \n");
		 }








		 /*
         WSA_IO_INCOMPLETE 
         996 
         Overlapped I/O event object not in signaled state. 
         The application has tried to determine the status of an overlapped 
		 operation which is not yet completed. Applications that use 
		 WSAGetOverlappedResult (with the fWait flag set to FALSE) in a polling
		 mode to determine when an overlapped operation has completed, get this
		 error code until the operation is complete. Note that this error is 
		 returned by the operating system, so the error number may change in future
		 releases of Windows.
		 */		 
         if(996==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_IO_INCOMPLETE'' \n");
		 }








		 /*
         WSA_IO_PENDING 
         997 
		 Overlapped operations will complete later. 
         The application has initiated an overlapped operation that cannot be 
		 completed immediately. A completion indication will be given later when 
		 the operation has been completed. Note that this error is returned by the
		 operating system, so the error number may change in future releases of 
		 Windows.
		 */
		 
         if(997==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_IO_PENDING'' \n");
		 }








		 /*
         WSAEINTR 
		 10004 
         Interrupted function call. 
         A blocking operation was interrupted by a call to WSACancelBlockingCall.
		 */		 
         if(WSAEINTR==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEINTR'' \n");
		 }








		 /*
         WSAEBADF 
         10009 
         File handle is not valid. 
         The file handle supplied is not valid.
		 */		 
         if(WSAEBADF==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEBADF'' \n");
		 }








		 /*
         WSAEACCES 
		 10013 
		 Permission denied. 
         An attempt was made to access a socket in a way forbidden by its access
		 permissions. An example is using a broadcast address for sendto without
		 broadcast permission being set using setsockopt(SO_BROADCAST). 

         Another possible reason for the WSAEACCES error is that when the bind function is called 
		 (on Windows NT 4.0 with SP4 and later), another application, service, or kernel mode 
		 driver is bound to the same address with exclusive access. Such exclusive access is a
		 new feature of Windows NT 4.0 with SP4 and later, and is implemented by using the 
		 SO_EXCLUSIVEADDRUSE option.
		 */		 
         if(WSAEACCES==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEACCES'' \n");
		 }








		 /*
         WSAEFAULT 
         10014 
         Bad address. 
		 The system detected an invalid pointer address in attempting to use a pointer 
		 argument of a call. This error occurs if an application passes an invalid pointer 
		 value, or if the length of the buffer is too small. For instance, if the length of
		 an argument, which is a sockaddr structure, is smaller than the sizeof(sockaddr).
		 */		 
         if(WSAEFAULT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEFAULT'' \n");
		 }








		 /*
         WSAEINVAL 
         10022 
         Invalid argument. 
         Some invalid argument was supplied (for example, specifying an invalid level to the 
		 setsockopt function). In some instances, it also refers to the current state of the 
		 socketfor instance, calling accept on a socket that is not listening.
		 */		 
         if(WSAEINVAL==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEINVAL'' \n");
		 }








		 /*
         WSAEMFILE 
         10024 
         Too many open files. 
         Too many open sockets. Each implementation may have a maximum number of socket 
		 handles available, either globally, per process, or per thread.
		 */	 
         if(WSAEMFILE==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEMFILE'' \n");
		 }








		 /*
         WSAEWOULDBLOCK 
         10035 
         Resource temporarily unavailable. 
		 This error is returned from operations on nonblocking sockets that cannot be 
		 completed immediately, for example recv when no data is queued to be read from
		 the socket. It is a nonfatal error, and the operation should be retried later.
		 It is normal for WSAEWOULDBLOCK to be reported as the result from calling connect
		 on a nonblocking SOCK_STREAM socket, since some time must elapse for the 
		 connection to be established.
		 */		 
         if(WSAEWOULDBLOCK==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEWOULDBLOCK '' \n");
		 }








		 /*
         WSAEINPROGRESS 
         10036 
         Operation now in progress. 
         A blocking operation is currently executing. Windows Sockets only allows a single 
		 blocking operationper- task or threadto be outstanding, and if any other function
		 call is made (whether or not it references that or any other socket) the function
		 fails with the WSAEINPROGRESS error.
		 */	 
         if(WSAEINPROGRESS==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEINPROGRESS'' \n");
		 }








		 /*
         WSAEALREADY 
         10037 
         Operation already in progress. 
         An operation was attempted on a nonblocking socket with an operation already in 
		 progressthat is, calling connect a second time on a nonblocking socket that is 
		 already connecting, or canceling an asynchronous request (WSAAsyncGetXbyY) that 
		 has already been canceled or completed.
		 */		 
         if(WSAEALREADY==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEALREADY'' \n");
		 }








		 /*
         WSAENOTSOCK 
         10038 
         Socket operation on nonsocket. 
         An operation was attempted on something that is not a socket. Either the socket
		 handle parameter did not reference a valid socket, or for select, a member of 
		 an fd_set was not valid.
		 */		 
         if(WSAENOTSOCK==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENOTSOCK'' \n");
		 }








		 /*
         WSAEDESTADDRREQ 
		 10039 
         Destination address required. 
         A required address was omitted from an operation on a socket. For example, this 
		 error is returned if sendto is called with the remote address of ADDR_ANY.
		 */		 
         if(WSAEDESTADDRREQ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEDESTADDRREQ'' \n");
		 }








		 /*
         WSAEMSGSIZE 
		 10040 
		 Message too long. 
		 A message sent on a datagram socket was larger than the internal message buffer 
		 or some other network limit, or the buffer used to receive a datagram was smaller
		 than the datagram itself.
		 */ 
         if(WSAEMSGSIZE==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEMSGSIZE'' \n");
		 }








		 /*
         WSAEPROTOTYPE 
		 10041 
		 Protocol wrong type for socket. 
		 A protocol was specified in the socket function call that does not support the 
		 semantics of the socket type requested. For example, the ARPA Internet UDP 
		 protocol cannot be specified with a socket type of SOCK_STREAM.
		 */	 
         if(WSAEPROTOTYPE==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEPROTOTYPE'' \n");
		 }








		 /*
         WSAENOPROTOOPT 
		 10042 
		 Bad protocol option. 
		 An unknown, invalid or unsupported option or level 
		 was specified in a getsockopt or setsockopt call.
		 */		 
         if(WSAENOPROTOOPT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENOPROTOOPT'' \n");
		 }








		 /*
         WSAEPROTONOSUPPORT 
         10043 
         Protocol not supported. 
         The requested protocol has not been configured into the system, 
		 or no implementation for it exists. For example, a socket call 
		 requests a SOCK_DGRAM socket, but specifies a stream protocol.
		 */		 
         if(WSAEPROTONOSUPPORT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEPROTONOSUPPORT'' \n");
		 }








		 /*
         WSAESOCKTNOSUPPORT 
		 10044 
		 Socket type not supported. 
         The support for the specified socket type does not exist in this 
		 address family. For example, the optional type SOCK_RAW might be 
		 selected in a socket call, and the implementation does not support 
		 SOCK_RAW sockets at all.
		 */	 
         if(WSAESOCKTNOSUPPORT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAESOCKTNOSUPPORT'' \n");
		 }








		 /*
         WSAEOPNOTSUPP 
         10045 
		 Operation not supported. 
		 The attempted operation is not supported for the type of object 
		 referenced. Usually this occurs when a socket descriptor to a socket 
		 that cannot support this operation is trying to accept a connection 
		 on a datagram socket.
		 */	 
         if(WSAEOPNOTSUPP==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEOPNOTSUPP'' \n");
		 }









		 /*
         WSAEPFNOSUPPORT 
         10046 
		 Protocol family not supported. The protocol family has not been configured
		 into the system or no implementation for it exists. This message has a 
		 slightly different meaning from WSAEAFNOSUPPORT. However, it is 
		 interchangeable in most cases, and all Windows Sockets functions that 
		 return one of these messages also specify WSAEAFNOSUPPORT.
		 */	 
         if(WSAEPFNOSUPPORT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEPFNOSUPPORT'' \n");
		 }









		 /*
         WSAEAFNOSUPPORT 
		 10047 
		 Address family not supported by protocol family. An address incompatible
		 with the requested protocol was used. All sockets are created with an associated
		 address family (that is, AF_INET for Internet Protocols) and a generic protocol 
		 type (that is, SOCK_STREAM). This error is returned if an incorrect protocol is 
		 explicitly requested in the socket call, or if an address of the wrong family is 
		 used for a socket, for example, in sendto.
		 */	 
         if(WSAEAFNOSUPPORT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEAFNOSUPPORT'' \n");
		 }









		 /*
         WSAEADDRINUSE 
         10048 
         Address already in use. 
         Typically, only one usage of each socket address (protocol/IP address/port)
		 is permitted. This error occurs if an application attempts to bind a socket
		 to an IP address/port that has already been used for an existing socket, or a 
		 socket that was not closed properly, or one that is still in the process of 
		 closing. For server applications that need to bind multiple sockets to the same
		 port number, consider using setsockopt (SO_REUSEADDR). Client applications 
		 usually need not call bind at allconnect chooses an unused port automatically.
		 When bind is called with a wildcard address (involving ADDR_ANY), a 
		 WSAEADDRINUSE error could be delayed until the specific address is committed.
		 This could happen with a call to another function later, including connect, 
		 listen, WSAConnect, or WSAJoinLeaf.
		 */	 
         if(WSAEADDRINUSE==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEADDRINUSE'' \n");
		 }









		 /*
         WSAEADDRNOTAVAIL 
         10049 
         Cannot assign requested address. 
         The requested address is not valid in its context. This normally results from
		 an attempt to bind to an address that is not valid for the local computer. This
		 can also result from connect, sendto, WSAConnect, WSAJoinLeaf, or WSASendTo when
		 the remote address or port is not valid for a remote computer (for example, 
		 address or port 0).
		 */	 
         if(WSAEADDRNOTAVAIL==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEADDRNOTAVAIL'' \n");
		 }









		 /*
         WSAENETDOWN 
         10050 
         Network is down. 
         A socket operation encountered a dead network. This could indicate a serious 
		 failure of the network system (that is, the protocol stack that the Windows 
		 Sockets DLL runs over), the network interface, or the local network itself.
		 */	 
         if(WSAENETDOWN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENETDOWN'' \n");
		 }









		 /*
         WSAENETUNREACH 
         10051 
         Network is unreachable. 
         A socket operation was attempted to an unreachable network. This usually means 
		 the local software knows no route to reach the remote host.
		 */	 
         if(WSAENETUNREACH==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENETUNREACH'' \n");
		 }









		 /*
         WSAENETRESET 
         10052 
         Network dropped connection on reset. 
         The connection has been broken due to keep-alive activity detecting a failure while
		 the operation was in progress. It can also be returned by setsockopt if an attempt
		 is made to set SO_KEEPALIVE on a connection that has already failed.
		 */	 
         if(WSAENETRESET==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENETRESET'' \n");
		 }









		 /*
         WSAECONNABORTED 
         10053 
         Software caused connection abort. 
         An established connection was aborted by the software in your host computer,
		 possibly due to a data transmission time-out or protocol error.
		 */	 
         if(WSAECONNABORTED==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAECONNABORTED'' \n");
		 }









		 /*
         WSAECONNRESET  
         10054 
         Connection reset by peer. 
         An existing connection was forcibly closed by the remote host. This normally
		 results if the peer application on the remote host is suddenly stopped, the host
		 is rebooted, the host or remote network interface is disabled, or the remote host
		 uses a hard close (see setsockopt for more information on the SO_LINGER option on
		 the remote socket). This error may also result if a connection was broken due to 
		 keep-alive activity detecting a failure while one or more operations are in progress.
		 Operations that were in progress fail with WSAENETRESET. Subsequent operations fail
		 with WSAECONNRESET.
		 */	 
         if(WSAECONNRESET==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAECONNRESET'' \n");
		 }









		 /*
         WSAENOBUFS 
         10055 
         No buffer space available. 
         An operation on a socket could not be performed because the system lacked sufficient
		 buffer space or because a queue was full.
		 */	 
         if(WSAENOBUFS==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENOBUFS'' \n");
		 }









		 /*
         WSAEISCONN 
         10056 
         Socket is already connected. 
         A connect request was made on an already-connected socket. 
		 Some implementations also return this error if sendto is called on a connected SOCK_DGRAM
		 socket (for SOCK_STREAM sockets, the to parameter in sendto is ignored) although other 
		 implementations treat this as a legal occurrence.
		 */	 
         if(WSAEISCONN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEISCONN'' \n");
		 }









		 /*
         WSAENOTCONN 
		 10057 
		 Socket is not connected. 
         A request to send or receive data was disallowed because the socket is not connected and
		 (when sending on a datagram socket using sendto) no address was supplied. Any other type
		 of operation might also return this errorfor example, setsockopt setting SO_KEEPALIVE if
		 the connection has been reset.
		 */	 
         if(WSAENOTCONN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENOTCONN'' \n");
		 }









		 /*
         WSAESHUTDOWN 
         10058 
         Cannot send after socket shutdown. 
         A request to send or receive data was disallowed because the socket had already been shut 
		 down in that direction with a previous shutdown call. By calling shutdown a partial close 
		 of a socket is requested, which is a signal that sending or receiving, or both have been 
		 discontinued.
		 */	 
         if(WSAESHUTDOWN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAESHUTDOWN'' \n");
		 }









		 /*
         WSAETOOMANYREFS 
         10059 
         Too many references. 
         Too many references to some kernel object.
		 */	 
         if(WSAETOOMANYREFS==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAETOOMANYREFS'' \n");
		 }









		 /*
         WSAETIMEDOUT 
		 10060 
		 Connection timed out. 
         A connection attempt failed because the connected party did not properly respond after
		 a period of time, or the established connection failed because the connected host has 
		 failed to respond.
		 */	 
         if(WSAETIMEDOUT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAETIMEDOUT'' \n");
		 }









		 /*
         WSAECONNREFUSED 
         10061 
         Connection refused. 
         No connection could be made because the target computer actively refused it. This 
		 usually results from trying to connect to a service that is inactive on the foreign
		 hostthat is, one with no server application running.
		 */	 
         if(WSAECONNREFUSED==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAECONNREFUSED'' \n");
		 }









		 /*
         WSAELOOP 
         10062 
         Cannot translate name. 
		 Cannot translate a name.
		 */	 
         if(WSAELOOP==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAELOOP'' \n");
		 }









		 /*
         WSAENAMETOOLONG 
         10063 
         Name too long. 
         A name component or a name was too long.
		 */	 
         if(WSAENAMETOOLONG==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENAMETOOLONG'' \n");
		 }









		 /*
         WSAEHOSTDOWN 
         10064 
         Host is down. 
         A socket operation failed because the destination host is down. A socket operation
		 encountered a dead host. Networking activity on the local host has not been 
		 initiated. These conditions are more likely to be indicated by the error WSAETIMEDOUT.
		 */	 
         if(WSAEHOSTDOWN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEHOSTDOWN'' \n");
		 }









		 /*
         WSAEHOSTDOWN 
         10065 
         No route to host. 
         A socket operation was attempted to an unreachable host. See WSAENETUNREACH.
		 */	 
         if(WSAEHOSTDOWN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEHOSTDOWN'' \n");
		 }









		 /*
         WSAENOTEMPTY 
         10066 
         Directory not empty. 
         Cannot remove a directory that is not empty.		
		 */	 
         if(WSAENOTEMPTY==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENOTEMPTY'' \n");
		 }









		 /*
         WSAEPROCLIM 
         10067 
         Too many processes. 
         A Windows Sockets implementation may have a limit on the number of applications
		 that can use it simultaneously. WSAStartup may fail with this error if the limit
		 has been reached.
		 */	 
         if(WSAEPROCLIM ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEPROCLIM'' \n");
		 }









		 /*
         WSAEUSERS 
         10068 
         User quota exceeded. 
         Ran out of user quota.		
		 */	 
         if(WSAEUSERS==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEUSERS'' \n");
		 }









		 /*
         WSAEDQUOT 
         10069 
         Disk quota exceeded. 
         Ran out of disk quota.
		 */	 
         if(WSAEDQUOT==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEDQUOT'' \n");
		 }









		 /*
         WSAESTALE 
         10070 
         Stale file handle reference. 
         The file handle reference is no longer available.
		 */	 
         if(WSAESTALE==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAESTALE'' \n");
		 }









		 /*
         WSAEREMOTE 
         10071 
         Item is remote. 
         The item is not available locally. 
		 */	 
         if(WSAEREMOTE==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEREMOTE'' \n");
		 }









		 /*
         WSASYSNOTREADY 
         10091 
         Network subsystem is unavailable. 
         This error is returned by WSAStartup if the Windows Sockets implementation cannot function
		 at this time because the underlying system it uses to provide network services is currently
		 unavailable. Users should check:

         1) That the appropriate Windows Sockets DLL file is in the current path. 

         2) That they are not trying to use more than one Windows Sockets implementation
		   simultaneously. If there is more than one Winsock DLL on your system, be sure 
		   the first one in the path is appropriate for the network subsystem currently loaded.

		 3) The Windows Sockets implementation documentation to be sure all necessary 
		   components are currently installed and configured correctly.
		 */	 
         if(WSASYSNOTREADY==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSASYSNOTREADY'' \n");
		 }









		 /*
         WSAVERNOTSUPPORTED 
         10092 
         Winsock.dll version out of range. 
         The current Windows Sockets implementation does not support the Windows Sockets 
		 specification version requested by the application. Check that no old Windows 
		 Sockets DLL files are being accessed.
		 */	 
         if(WSAVERNOTSUPPORTED==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAVERNOTSUPPORTED'' \n");
		 }









		 /*
         WSANOTINITIALISED 
         10093 
         Successful WSAStartup not yet performed. 
         Either the application has not called WSAStartup or WSAStartup failed. 
		 The application may be accessing a socket that the current active task does not own 
		 (that is, trying to share a socket between tasks), or WSACleanup has been called
		 too many times.
		 */	 
         if(WSANOTINITIALISED==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSANOTINITIALISED'' \n");
		 }









		 /*
         WSAEDISCON 
         10101 
         Graceful shutdown in progress. 
         Returned by WSARecv and WSARecvFrom to indicate that the remote party has 
		 initiated a graceful shutdown sequence.
		 */	 
         if(WSAEDISCON==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEDISCON'' \n");
		 }









		 /*
         WSAENOMORE 
         10102 
         No more results. 
         No more results can be returned by the WSALookupServiceNext function.
		 */	 
         if(10102==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAENOMORE'' \n");
		 }









		 /*
         WSAECANCELLED 
         10103 
         Call has been canceled. 
         A call to the WSALookupServiceEnd function was made while this call was 
		 still processing. The call has been canceled.
		 */	 
         if(10103==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAECANCELLED'' \n");
		 }









		 /*
         WSAEINVALIDPROCTABLE 
         10104 
         Procedure call table is invalid. 
         The service provider procedure call table is invalid. A service provider 
		 returned a bogus procedure table to Ws2_32.dll. This is usually caused by 
		 one or more of the function pointers being NULL.
		 */	 
         if(10104 ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEINVALIDPROCTABLE'' \n");
		 }









		 /*
         WSAEINVALIDPROVIDER 
         10105 
         Service provider is invalid. 
         The requested service provider is invalid. This error is returned by the 
		 WSCGetProviderInfo and WSCGetProviderInfo32 functions if the protocol 
		 entry specified could not be found. This error is also returned if the 
		 service provider returned a version number other than 2.0.
		 */	 
         if(10105 ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEINVALIDPROVIDER'' \n");
		 }









		 /*
         WSAEPROVIDERFAILEDINIT 
         10106 
         Service provider failed to initialize. 
         The requested service provider could not be loaded or initialized. This
		 error is returned if either a service provider's DLL could not be loaded
		 (LoadLibrary failed) or the provider's WSPStartup or NSPStartup function
		 failed.
		 */	 
         if(10106==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEPROVIDERFAILEDINIT'' \n");
		 }









		 /*
         WSASYSCALLFAILURE 
         10107 
         System call failure. 
         A system call that should never fail has failed. This is a generic error
		 code, returned under various conditions.
		 
         Returned when a system call that should never fail does fail. For example,
		 if a call to WaitForMultipleEvents fails or one of the registry functions
		 fails trying to manipulate the protocol/namespace catalogs.

         Returned when a provider does not return SUCCESS and does not provide an
		 extended error code. Can indicate a service provider implementation error.
		 */	 
         if(10107==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSASYSCALLFAILURE'' \n");
		 }









		 /*
         WSASERVICE_NOT_FOUND 
         10108 
         Service not found. 
         No such service is known. The service cannot be found in the specified
		 name space.
		 */	 
         if(10108==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSASERVICE_NOT_FOUND'' \n");
		 }









		 /*
         WSATYPE_NOT_FOUND 
         10109 
         Class type not found. 
         The specified class was not found.
		 */	 
         if( 10109==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSATYPE_NOT_FOUND'' \n");
		 }









		 /*
         WSA_E_NO_MORE 
         10110 
         No more results. 
         No more results can be returned by the WSALookupServiceNext function.
		 */	 
         if(10110 ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_E_NO_MORE'' \n");
		 }









		 /*
         WSA_E_CANCELLED 
         10111 
         Call was canceled. 
         A call to the WSALookupServiceEnd function was made while this call
		 was still processing. The call has been canceled.
		 */	 
         if(10111==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_E_CANCELLED'' \n");
		 }









		 /*
         WSAEREFUSED 
         10112 
         Database query was refused. 
         A database query failed because it was actively refused.
		 */	 
         if(10112 ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAEREFUSED'' \n");
		 }









		 /*
         WSAHOST_NOT_FOUND 
         11001 
         Host not found. 
         No such host is known. The name is not an official host name or alias, or
		 it cannot be found in the database(s) being queried. This error may also be
		 returned for protocol and service queries, and means that the specified
		 name could not be found in the relevant database.
		 */	 
         if(WSAHOST_NOT_FOUND==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSAHOST_NOT_FOUND'' \n");
		 }









		 /*
         WSATRY_AGAIN 
         11002 
         Nonauthoritative host not found. 
         This is usually a temporary error during host name resolution and means
		 that the local server did not receive a response from an authoritative
		 server. A retry at some time later may be successful.
		 */	 
         if(WSATRY_AGAIN==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSATRY_AGAIN'' \n");
		 }









		 /*
         WSANO_RECOVERY 
         11003 
         This is a nonrecoverable error. 
         This indicates that some sort of nonrecoverable error occurred during a
		 database lookup. This may be because the database files (for example,
		 BSD-compatible HOSTS, SERVICES, or PROTOCOLS files) could not be found,
		 or a DNS request was returned by the server with a severe error.
		 */	 
         if(WSANO_RECOVERY==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSANO_RECOVERY'' \n");
		 }









		 /*
         WSANO_DATA 
         11004 
         Valid name, no data record of requested type. 
         The requested name is valid and was found in the database, but it does not
		 have the correct associated data being resolved for. The usual example for
		 this is a host name-to-address translation attempt (using gethostbyname or
		 WSAAsyncGetHostByName) which uses the DNS (Domain Name Server). An MX
		 record is returned but no A recordindicating the host itself exists, but
		 is not directly reachable.
		 */	 
         if(WSANO_DATA==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSANO_DATA'' \n");
		 }









		 /*
         WSA_QOS_RECEIVERS 
         11005 
         QoS receivers. 
         At least one QoS reserve has arrived.
		 */	 
         if(11005==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_RECEIVERS'' \n");
		 }









		 /*
         WSA_QOS_SENDERS 
         11006 
         QoS senders. 
         At least one QoS send path has arrived.
		 */	 
         if(11006==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_SENDERS'' \n");
		 }









		 /*
         WSA_QOS_NO_SENDERS 
         11007 
         No QoS senders. 
         There are no QoS senders.
		 */	 
         if(11007==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_NO_SENDERS'' \n");
		 }









		 /*
         WSA_QOS_NO_RECEIVERS 
         11008 
         QoS no receivers. 
         There are no QoS receivers.
		 */	 
         if(11008==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_NO_RECEIVERS'' \n");
		 }









		 /*
         WSA_QOS_REQUEST_CONFIRMED 
         11009 
         QoS request confirmed. 
         The QoS reserve request has been confirmed.
		 */	 
         if(11009==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_REQUEST_CONFIRMED'' \n");
		 }









		 /*
         WSA_QOS_ADMISSION_FAILURE 
         11010 
         QoS admission error. 
         A QoS error occurred due to lack of resources.
		 */	 
         if(11010==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_ADMISSION_FAILURE'' \n");
		 }









		 /*
         WSA_QOS_POLICY_FAILURE 
         11011 
         QoS policy failure. 
         The QoS request was rejected because the policy system couldn't allocate
		 the requested resource within the existing policy.
		 */	 
         if(11011==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_POLICY_FAILURE'' \n");
		 }









		 /* 
         WSA_QOS_BAD_STYLE 
         11012 
         QoS bad style. 
         An unknown or conflicting QoS style was encountered.
		 */	 
         if(11012 ==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_BAD_STYLE'' \n");
		 }









		 /*
         WSA_QOS_BAD_OBJECT 
         11013 
         QoS bad object. 
         A problem was encountered with some part of the filterspec or the 
		 provider-specific buffer in general.
		 */	 
         if(11013==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_BAD_OBJECT'' \n");
		 }









		 /*
         WSA_QOS_TRAFFIC_CTRL_ERROR 
         11014 
         QoS traffic control error. 
         An error with the underlying traffic control (TC) API as the generic QoS 
		 request was converted for local enforcement by the TC API. This could be
		 due to an out of memory error or to an internal QoS provider error.
		 */	 
         if(11014==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_TRAFFIC_CTRL_ERROR'' \n");
		 }









		 /* 
         WSA_QOS_GENERIC_ERROR 
         11015 
         QoS generic error. 
         A general QoS error.
		 */	 
         if(11015==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_GENERIC_ERROR'' \n");
		 }









		 /*
         WSA_QOS_ESERVICETYPE 
         11016 
         QoS service type error. 
         An invalid or unrecognized service type was found in the QoS flowspec.
		 */	 
         if(11016==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_ESERVICETYPE'' \n");
		 }









		 /*
         WSA_QOS_EFLOWSPEC 
         11017 
         QoS flowspec error. 
         An invalid or inconsistent flowspec was found in the QOS structure.
		 */	 
         if(11017==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EFLOWSPEC'' \n");
		 }









		 /*
         WSA_QOS_EPROVSPECBUF 
         11018 
         Invalid QoS provider buffer. 
         An invalid QoS provider-specific buffer.
		 */	 
         if(11018==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EPROVSPECBUF'' \n");
		 }









		 /*
         WSA_QOS_EFILTERSTYLE 
         11019 
         Invalid QoS filter style. 
         An invalid QoS filter style was used.
		 */	 
         if(11019==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EFILTERSTYLE'' \n");
		 }









		 /*
         WSA_QOS_EFILTERTYPE 
         11020 
         Invalid QoS filter type. 
         An invalid QoS filter type was used.
		 */	 
         if(11020==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EFILTERTYPE'' \n");
		 }









		 /*
         WSA_QOS_EFILTERCOUNT 
         11021 
         Incorrect QoS filter count. 
         An incorrect number of QoS FILTERSPECs were specified in the FLOWDESCRIPTOR.
		 */	 
         if(11021==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EFILTERCOUNT'' \n");
		 }









		 /*
         WSA_QOS_EOBJLENGTH 
         11022 
         Invalid QoS object length. 
         An object with an invalid ObjectLength field was specified in the QoS
		 provider-specific buffer.
		 */	 
         if(11022==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EOBJLENGTH'' \n");
		 }









		 /*
         WSA_QOS_EFLOWCOUNT 
         11023 
         Incorrect QoS flow count. 
         An incorrect number of flow descriptors was specified in the QoS structure.
		 */	 
         if(11023==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EFLOWCOUNT'' \n");
		 }









		 /*
         WSA_QOS_EUNKOWNPSOBJ 
         11024 
         Unrecognized QoS object. 
         An unrecognized object was found in the QoS provider-specific buffer.
		 */	 
         if(11024==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EUNKOWNPSOBJ'' \n");
		 }









		 /*
         WSA_QOS_EPOLICYOBJ 
         11025  
         Invalid QoS policy object. 
         An invalid policy object was found in the QoS provider-specific buffer.
		 */	 
         if(11025==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EPOLICYOBJ'' \n");
		 }









		 /*
         WSA_QOS_EFLOWDESC 
         11026 
         Invalid QoS flow descriptor. 
         An invalid QoS flow descriptor was found in the flow descriptor list.
		 */	 
         if(11026==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EFLOWDESC'' \n");
		 }









		 /*
         WSA_QOS_EPSFLOWSPEC 
         11027 
         Invalid QoS provider-specific flowspec. 
         An invalid or inconsistent flowspec was found in the QoS provider-specific
		 buffer.
		 */	 
         if(11027==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EPSFLOWSPEC'' \n");
		 }









		 /*
         WSA_QOS_EPSFILTERSPEC 
         11028 
         Invalid QoS provider-specific filterspec. 
         An invalid FILTERSPEC was found in the QoS provider-specific buffer.
		 */	 
         if(11028==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_EPSFILTERSPEC'' \n");
		 }









		 /*
         WSA_QOS_ESDMODEOBJ 
         11029 
         Invalid QoS shape discard mode object. 
         An invalid shape discard mode object was found in the QoS provider-specific buffer.
		 */	 
         if(11029==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_ESDMODEOBJ'' \n");
		 }









		 /*
         WSA_QOS_ESHAPERATEOBJ 
         11030 
         Invalid QoS shaping rate object. 
         An invalid shaping rate object was found in the QoS provider-specific buffer.
		 */	 
         if(11030==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_ESHAPERATEOBJ'' \n");
		 }









		 /*
         WSA_QOS_RESERVED_PETYPE 
         11031 
         Reserved policy QoS element type. 
         A reserved policy element was found in the  in the QoS provider-specific buffer.
         */	 
         if(11031==WSAGetLastError_ERROR_message)
		 {
           printf("WSAGetLastError CODE:''WSA_QOS_RESERVED_PETYPE'' \n");
		 }






if (2==3)
{

      printf("\n\n\n*");
	   Sleep(1000);
	  printf("*");
	   Sleep(1000);
	  printf("*\n");
	   Sleep(1000);

}
		
	 


		return;
	}




	void private_REPORT_WSAStartup_ERROR(int WSAStartup_ERROR_message )
	{

     /*

     WSASYSNOTREADY        The underlying network subsystem is not ready for network
	                       communication.
 
     WSAVERNOTSUPPORTED    The version of Windows Sockets support requested is not 
	                      provided by this particular Windows Sockets implementation.
 
     WSAEINPROGRESS        A blocking Windows Sockets 1.1 operation is in progress.
 
     WSAEPROCLIM           A limit on the number of tasks supported by the Windows 
	                       Sockets implementation has been reached.
 
     WSAEFAULT             The lpWSAData parameter is not a valid pointer
 

     */

		printf("private_REPORT_WSAStartup_ERROR results.... \n");



      if (WSASYSNOTREADY ==WSAStartup_ERROR_message)
	  {
	     printf("WSAStartup_ERROR:WSASYSNOTREADY \n");
		 
	  }


	  
      if (WSAVERNOTSUPPORTED ==WSAStartup_ERROR_message)
	  {
	     printf("WSAStartup_ERROR:WSAVERNOTSUPPORTED \n");
		
	  }


	   if (WSAEINPROGRESS ==WSAStartup_ERROR_message)
	  {
	     printf("WSAStartup_ERROR:WSAEINPROGRESS \n");
	
	  }


	    if (WSAEPROCLIM ==WSAStartup_ERROR_message)
	  {
	     printf("WSAStartup_ERROR:WSAEPROCLIM \n");
		 
	  }

		
		if (WSAEFAULT ==WSAStartup_ERROR_message)
	  {
	     printf("WSAStartup_ERROR:WSAEFAULT \n");
		
	  }


		Sleep(1000);


      return;
	}



	
 
};//END ****************** class LAN_Socket_Ethernet_class *****************************

#endif
